; Hello Everyone this is the source code for the Coco version of Bob and the alien fireflies. The thing about it is that it was written as a learning excersise in
; order to teach myself 6809 assembly code. I've included it here because although it's far from being well written, optomised and coherent it may well help some
; one in putting their own game together. Pay little attention to the comments; they will explain what the lines and chunks of code do but the addresses that they
; refer to are not always marked correctly. This was a learning process after all and many changes were made to the code along the way. I just didn't always reflect
; the changes in the comments. The code will compile and run as is using LWASM. Have fun...

;changed 2 player clock to 4, bottle is better drawn and put lda #2 sta $ff20 (to close off serial bit banger port) at beginning of sound routines.

lineleft_pos        equ     $00         ;16 bit         ;byte position of top of left line       
lineleft_pixel      equ     $02         ;8 bit          ;pixel position of left line     
lineleft_counter    equ     $03         ;8 bit          ;length to draw top portion of left line 
lineleft_slave      equ     $04         ;16 bit         ;byte position of top of opening on left line
lineleft_master     equ     $06         ;16 bit         ;byte position of bottom of opening on left line     
lineright_pos       equ     $08         ;16 bit              
lineright_pixel     equ     $0a         ;8 bit             
lineright_counter   equ     $0b         ;8 bit           
lineright_slave     equ     $0c         ;16 bit
lineright_master    equ     $0e         ;16 bit             
bug_counter1        equ     $10         ;8 bit          ;8 bit counter controls bug animation        
bug_counter2        equ     $11         ;8 bit          ;8 bit counter controls bug colour change  
bug_rndpos          equ     $12         ;16 bit         ;byte for bug placement
anim_counter        equ     $14         ;8 bit          ;counter to track Bob animation frame
hog_anim_counter    equ     $15         ;8 bit                
system_clock        equ     $16         ;8 bit          ;counter to time main loop
position            equ     $17         ;16 bit         ;byte Bob is currently drawn in
xpos                equ     $19         ;8 bit          ;Used for collision Bob's x location (1-128)
ypos                equ     $1a         ;8 bit          ;Used for collision Bob's y location (1-144)
animation           equ     $1b         ;8 bit          ;store for Bob current animation frame (1-4)
direction           equ     $1c         ;8 bit          ;Bob direction flag facing left or right (1-2)
lineleft_x          equ     $1d         ;8 bit          ;Collision x location left line (1-128)
linelefttop_y       equ     $1e         ;8 bit          ;Collision y location left line top opening (1-144)
lineleftbottom_y    equ     $1f         ;8 bit          ;Collision y location left line bottom opening (1-144)
lineright_x         equ     $20         ;8 bit
linerighttop_y      equ     $21         ;8 bit
linerightbottom_y   equ     $22         ;8 bit
bob1_x              equ     $23         ;8 bit          ;Bob (top sprite) x location for collision
bob1_y              equ     $24         ;8 bit          ;Bob (left sprite) y location for collision
bob4_x              equ     $25         ;8 bit          ;Bob (bottom sprite) x location for collision
bob4_y              equ     $26         ;8 bit          ;Bob (right sprite) y location for collision
fly1_x              equ     $27         ;8 bit
fly1_y              equ     $28         ;8 bit
fly4_x              equ     $29         ;8 bit
fly4_y              equ     $2a         ;8 bit
hog_position        equ     $2b         ;16 bit
hog_xpos            equ     $2d         ;8 bit
hog_ypos            equ     $2e         ;8 bit
hog_animation       equ     $2f         ;8 bit
hog_direction       equ     $30         ;8 bit
hog1_x              equ     $31         ;8 bit
hog1_y              equ     $32         ;8 bit
hog4_x              equ     $33         ;8 bit
hog4_y              equ     $34         ;8 bit
bob_score           equ     $36         ;8 bit          ;Bob score is held here in hex (using 8 bit registers to count score)
bob_rollover        equ     $35         ;8 bit          ;when bob_score exceeds ff this byte is incremented by 1 (giving total potential score of ffff)
hog_score           equ     $37         ;8 bit
line_length         equ     $39         ;8 bit          ;value placed here determines lines max length, used to make openings appear more quickly or slowly
plr1_speed          equ     $3a         ;8 bit          ;in one player game this value is used as the system clock spped for the main loop
bob_flag            equ     $3b         ;8 bit          ;used in 2 player game (1-3) is sprite active, invisible or invincible
hog_flag            equ     $3c         ;8 bit
game_type           equ     $3d         ;8 bit          ;is a one or two player game in session
bob_2p_counter      equ     $3e         ;8 bit          ;Counter for 2 player game to time length of invisible, invincible states *****this counter should be 8 bit
hog_2p_counter      equ     $3f         ;8 bit          ;***************one byte is enough for this counter***********
red1                equ     $43         ;8 bit          ;These are used to hold different animation (speed) counters for the bug in 2p game as speed poke used
red2                equ     $44         ;8 bit
red3                equ     $45         ;8 bit
bob_jar_pos         equ     $46         ;16 bit         ;in a 2 player game stores address of next firefly (point counter) for Bob on screen base
hog_jar_pos         equ     $48         ;16 bit

bugline1            equ     $80         ;8 bit          ;stores value that using wizardry can tell us if you get bonus points for bugs colours or not   
bugline2            equ     $81         ;8 bit ;********;blue stores 1, yellow 2 and red 3 **TIS' A BIT BUGGY THOUGH, 2xyel 1xred and 1xblue seen as full red**
bugline3            equ     $82         ;8 bit          ;the values can be added up to see if a line is all one colour blue=4, yellow=8 and red=12
bugline4            equ     $83         ;8 bit          ;or if all 16 fire flies are the same colour all blue=16, all yellow=32 and all red=48

bob_beep_flag       equ     $84         ;8 bit          
tone                equ     $85         ;8 bit
hog_beep_flag       equ     $86         ;8 bit

ascii_sc1           equ     $90         ;8 bit          ;used for converting hex score to ASCII units
ascii_sc2           equ     $91         ;8 bit          ;used for converting hex score to ASCII tens
ascii_sc3           equ     $92         ;8 bit          ;used for converting hex score to ASCII hundreds
ascii_sc4           equ     $93         ;8 bit          ;used for converting hex score to ASCII thousands
ascii_sc5           equ     $94         ;8 bit          ;used for converting hex score to ASCII ten_thousands UNUSED FOR NOW

player1_jar_map     equ     $95         ;8 bit          ;increments with score but reset at end of each level. Used to place fireflies on base of screen
player1_level       equ     $96         ;8 bit          ;level holder, increments during stages to show next level in text (1 player game only)
blue_total_line     equ     $97         ;8 bit          how many blue lines we got
yellow_total_line   equ     $98         ;8 bit          how many yellow lines we got
red_total_line      equ     $99         ;8 bit          how many red lines we got
full_blue           equ     $9a         ;8 bit          full block of blue bugs
full_yellow         equ     $9b         ;8 bit          full block of yellow bugs
full_red            equ     $9c         ;8 bit          full block of red bugs
bonus_calc          equ     $9d         ;8 bit          scratch pad for bonus calculations
todays_highest      equ     $d0         ;16 bit         Store highest score for display on title screen
buffer              equ     $52         ;16 bit         Buffer for score/number conversion 16bit
text_beep_counter   equ     $54         ;8 bit          Letters between beeps in text

End_anim_counter    equ     $fe         ;16 bit         ;counter for timings in end game animations


;*********************CODE START*****************************

		            org     $3600                   ;compiled program will begin at $2400
                    jsr     sg4_setup
                    lbra    prog_start

;***********START OF C6 GFX CODE***********************************************************

reset_game      sta     $ffc6+1                 ;screen address starts at $a00
		        sta     $ffc8
                sta     $ffca+1
                sta     $ffcc
                sta     $ffce
                sta     $ffd0
                sta     $ffd2

                lda     #%11100000              ; select mode C6
		        sta     $ff22                   ; and store it to the VDG
		        sta     $ffc3                   ; set V1
		        sta     $ffc5                   ; set V2
	
		        clra 		                    ;clear the contents of a
		        clrb                            ;clear the contents of b		        
                ldx     #$a00	                ;load the value $600 to x
clear_screen	std     ,x++                    ;load the contents of d to x(a and b were cleared above so d now contains 0) and move the x pointer two bytes
		        cmpx    #$2200                  ;compare the value in x to $1e00 to check if it's got to the end of the screen buffer yet
		        blo     clear_screen            ;if the value in x is lower than $1c00 branch back branch back to clear_screen

;*******************INITIAL SETUP STARTS HERE***************************************
      
                clra
                clrb
                clr     text_beep_counter
                clr     bug_counter1
                clr     bug_counter2
                std     bug_rndpos
                clr     system_clock
                clr     hog_flag
                clr     bob_flag 

                rts

;***********************************************************MAIN LOOP IS HERE***************************************************************************
                clra
                clrb                
                std     todays_highest
_1plr           jsr     reset_game
                
                jsr     $bf3b                   ;get random value and store it in x
                tfr     x,d                     ;transfer x to d, d is composed of a and b
                sta     lineleft_counter        
                stb     lineright_counter
          
                ldx     #$200                   ;starting position of left line (top left)
                stx     lineleft_pos            
                lda     #%10000000              ;load byte for single blue pixel (left side of byte)
                sta     lineleft_pixel          

                ldx     #$21f                   ;start position of right line (top right)
                stx     lineright_pos           
                lda     #%00000011              ;load byte for single red pixel (right side of byte)
                sta     lineright_pixel

                lda     #1                      ;set up collision detection locations for lines x axis
                sta     lineleft_x
                lda     #128
                sta     lineright_x

                lda     #212                    ;solid set for now but will change during gameplay ****************************************************
                sta     line_length
   
                lda     #15                 ;Note: xpos must corrolate with position below
                sta     xpos

                lda     #1
                sta     animation
                sta     game_type
                sta     player1_level

                ldx     #$15ef              ;Note: position must corrolate with bob y positions below
                stx     position

                lda     #96         
                sta     bob1_y
                lda     #103        
                sta     bob4_y

                lda     #9
                sta     red1
                lda     #18
                sta     red2
                lda     #27
                sta     red3
               
                lda     #5
                sta     plr1_speed   ;starting speed for 1p game, although it applys to all the code mainly it just affects the horizontal transporter speed
                
                clr     bob_rollover
                clr     bob_score
                clr     hog1_x
                clr     hog4_x
next_level      lda     player1_level
                cmpa    #5
                beq     level_up
                cmpa    #10
                beq     level_up
                cmpa    #15
                beq     level_up
after_level_up  jsr     reset_game
practice_mode   clr     hog_score               ;added label 01_05_24
                clr     bugline1
                clr     bugline2
                clr     bugline3
                clr     bugline4
                clr     bob_beep_flag
                clr     ascii_sc1
                clr     ascii_sc2
                clr     ascii_sc3
                clr     ascii_sc4
                clr     ascii_sc5
                clr     player1_jar_map
                clr     blue_total_line
                clr     yellow_total_line
                clr     red_total_line
                clr     full_blue
                clr     full_yellow
                clr     full_red
                clr     bonus_calc
                clr     $fe
                clr     $ff

                ldx     #$1c8a
                stx     bob_jar_pos
                jsr     drawjar1p

                ldx     bob_jar_pos
                jsr     cork1p

                ldx     bob_jar_pos         ;as bug placement is related to where the bottle is placed, add 40 so bugs are placed properly
                leax    $40,x
                stx     bob_jar_pos

main_loop_1plr  jsr     bob_sound
                jsr     joystick
                jsr     xtime
                jsr     lineleft
                jsr     lineright
                jsr     bobposition
                inc     system_clock
                lda     system_clock
                cmpa    plr1_speed
                blo     main_loop_1plr
                jsr     left_cont2_bob               ;leftlinecheck
                jsr     right_cont2_bob              ;rightlinecheck
                jsr     bobfly           
                jsr     lineleftclr                                   
                jsr     linerightclr                                   
                clr     system_clock            
                bra     main_loop_1plr

level_up        dec     plr1_speed
                bra     after_level_up
;------------------------------------------------Two player setup and main loop--------------------------------------------------------------------
_2plr           jsr     $bf3b                   ;get random value and store it in x
                tfr     x,d                     ;transfer x to d, d is composed of a and b
                sta     lineleft_counter        
                stb     lineright_counter
          
                ldx     #$200                   ;starting position of left line (top left)
                stx     lineleft_pos            
                lda     #%10000000              ;load byte for single blue pixel (left side of byte)
                sta     lineleft_pixel          

                ldx     #$21f                   ;start position of right line (top right)
                stx     lineright_pos           
                lda     #%00000011              ;load byte for single red pixel (right side of byte)
                sta     lineright_pixel

                lda     #1                      ;set up collision detection locations for lines x axis
                sta     lineleft_x
                lda     #128
                sta     lineright_x

                lda     #212                    ;solid set for now but will change during gameplay ****************************************************
                sta     line_length

                jsr     reset_game

                lda     #15
                sta     xpos
                sta     hog_xpos

                lda     #1
                sta     animation
                sta     hog_animation
                sta     player1_level

                lda     #2
                sta     game_type

                ldx     #$15ef
                stx     position

                ldx     #$bef
                stx     hog_position

                lda     #96         
                sta     bob1_y
                lda     #103        
                sta     bob4_y

                lda     #16         
                sta     hog1_y
                lda     #23        
                sta     hog4_y

                lda     #4
                sta     red1
                lda     #8
                sta     red2
                lda     #12
                sta     red3

                clr     bob_score
                clr     bob_rollover
                clr     hog_score
                clr     bob_flag
                clr     hog_flag
                clr     bob_beep_flag
                clr     hog_beep_flag
                clr     player1_jar_map
                clr     bob_2p_counter
                clr     hog_2p_counter

                ldx     #$1c81
                stx     bob_jar_pos
                jsr     drawjar1p
                ldx     bob_jar_pos
                jsr     cork1p

                ldx     bob_jar_pos
                leax    $40,x
                stx     bob_jar_pos

                ldx     #$1c9c
                stx     hog_jar_pos
                leax    -$9,x
                jsr     drawjar1p
                ldx     hog_jar_pos
                leax    -$9,x
                jsr     cork1p

                ldx     hog_jar_pos
                leax    $40,x
                stx     hog_jar_pos

main_loop_2plr  jsr     bob_sound
                jsr     hog_sound
                jsr     joystick
                jsr     hog_joystick
                jsr     xtime_2plr
                jsr     lineleft
                jsr     lineright
                jsr     bobposition
                jsr     hogposition
                inc     system_clock
                lda     system_clock
                cmpa    #4
                blo     main_loop_2plr
                jsr     left_bob_hog_check
                jsr     right_bob_hog_check
                jsr     bobfly
                jsr     hogfly           
                jsr     lineleftclr                                   
                jsr     linerightclr                                   
                clr     system_clock            
                bra     main_loop_2plr   

;*****************************************************SOUND CODE**********************************************************************************
bob_sound       lda bob_beep_flag
                cmpa    #1
                beq     beep_bob
                cmpa    #2
                beq beep_bob_2
                cmpa    #3
                beq beep_bob_3
                rts
beep_bob        lda #2
                sta bob_beep_flag
                ldb #$1f
                stb tone
                bra start_sound
beep_bob_2      lda #3
                sta bob_beep_flag
                ldb #$2f
                stb tone
                bra start_sound
beep_bob_3      lda #0
                sta bob_beep_flag
                ldb #$3f
                stb tone
                bra start_sound

hog_sound       lda hog_beep_flag
                cmpa    #1
                beq     beep_hog
                cmpa    #2
                beq beep_hog_2
                cmpa    #3
                beq beep_hog_3
                rts
beep_hog        lda #2
                sta hog_beep_flag
                ldb #$3f
                stb tone
                bra start_sound
beep_hog_2      lda #3
                sta hog_beep_flag
                ldb #$2f
                stb tone
                bra start_sound
beep_hog_3      lda #0
                sta hog_beep_flag
                ldb #$1f
                stb tone

start_sound     lda #$3f
                sta $ff23
                ldx #$0f
loadb           ldb tone
store           orb #%10
                stb $ff20
                incb
                bne store
                leax    -1,x
                bne loadb
                rts

;**************************************************************************************************************************************************
;**********************************************************Collision detection starts here*********************************************************

bobposition     lda xpos                ;load xpos into a
                ldb #4                  ;load decimal 4 to b
                mul                     ;multiply them, answer in b
                lda direction           ;load direction into a 
                cmpa #2                 ;see if direction is left left set to 2, right to 1
                beq leftmove            ;if it is go to leftmove
                lda animation           ;load animation to a
workout         incb                    ;increment result of multiplation by animation number
                deca
                bne     workout
                stb     bob1_x          ;store final result to bob1_x
                addb    #7
                stb     bob4_x
                rts                                                
leftmove        lda animation           ;this scetion does as above but reverses the numbers to be added
                cmpa #4                 ;4 becomes 1, 3 becomes 2 etc
                beq make1
                cmpa #3
                beq make2
                cmpa #2
                beq make3
                lda #4
                bra workout
make1           lda #1
                bra workout
make2           lda #2
                bra workout
make3           lda #3
                bra workout

hogposition     lda hog_xpos            ;load xpos into a
                ldb #4                  ;load decimal 4 to b
                mul                     ;multiply them, answer in b
                lda hog_direction       ;load direction into a 
                cmpa #2                 ;see if direction is left left set to 2, right to 1
                beq hog_leftmove        ;if it is go to leftmove
                lda hog_animation       ;load animation to a
hog_workout     incb                    ;increment result of multiplation by animation number
                deca
                bne     hog_workout
                stb     hog1_x          ;store final result to bob1_x
                addb    #7
                stb     hog4_x
                rts                                                
hog_leftmove    lda hog_animation       ;this scetion does as above but reverses the mumbers to be added
                cmpa #4                 ;4 becomes 1, 3 becomes 2 etc
                beq hog_make1
                cmpa #3
                beq hog_make2
                cmpa #2
                beq hog_make3
                lda #4
                bra hog_workout
hog_make1           lda #1
                bra hog_workout
hog_make2           lda #2
                bra hog_workout
hog_make3           lda #3
                bra hog_workout

bug_xy          clra                ;code to find fireflies xy coordinates
                clrb                ;X contains the firefly's screen address for it's top left byte
                leax    -$9e0,x     ;remove screen base address (less $20 to give lowest y pos of 1)  ****changed $5e0 to $600 to $5c0
divide          leax    -$20,x      ;we remove 32 from X again and again until it's value is lower than 32, effectly dividing by 32
                inca                ;and add one to A
                cmpx    #$1f        ;is x below 32?
                bhi     divide      ;if not run again
                sta     fly1_y      ;if x is below 32 then a contains the number of times 32 divides into X and the value in X is the remainder, a put in flys y pos
                tfr     x,d         ;transfer X to D, now remainder is in B
                lda     #4          
                mul                 ;multiply remainder by 4 to get x position
                stb     fly1_x
                addb    #7
                stb     fly4_x
                ldb     fly1_y
                addb    #7
                stb     fly4_y
                rts

bobfly          lda     bob1_x          ;Hit Detection code for Bob and Firefly
                cmpa    fly1_x
                beq     checky
                cmpa    fly4_x
                beq     checky
                lda     bob4_x
                cmpa    fly1_x
                beq     checky
                cmpa    fly4_x
                beq     checky
                lda     bob1_x
                cmpa    fly1_x
                bhi     check1
                blo     check2
check1          cmpa    fly4_x
                blo     checky
                rts
check2          lda     bob4_x
                cmpa    fly1_x
                bhi     checky
                rts
checky          lda     bob1_y          
                cmpa    fly1_y
                beq    bob_flag_chk
                cmpa    fly4_y
                beq    bob_flag_chk
                lda     bob4_y
                cmpa    fly1_y
                beq    bob_flag_chk
                cmpa    fly4_y
                beq    bob_flag_chk
                lda     bob1_y
                cmpa    fly1_y
                bhi     check1y
                blo     check2y
check1y         cmpa    fly4_y
                blo    bob_flag_chk
                rts
check2y         lda     bob4_y
                cmpa    fly1_y
                bhi    bob_flag_chk
                rts

bob_flag_chk    lda     bob_flag
                cmpa    #0
                bhi    return5
                bra     xclrbyte_bob
                

hogfly          lda     hog1_x          ;Hit Detection code for Hog and Firefly
                cmpa    fly1_x
                beq     hog_checky
                cmpa    fly4_x
                beq     hog_checky
                lda     hog4_x
                cmpa    fly1_x
                beq     hog_checky
                cmpa    fly4_x
                beq     hog_checky
                lda     hog1_x
                cmpa    fly1_x
                bhi     hog_check1
                blo     hog_check2
hog_check1      cmpa    fly4_x
                blo     hog_checky
                rts
hog_check2      lda     hog4_x
                cmpa    fly1_x
                bhi     hog_checky
                rts
hog_checky      lda     hog1_y          
                cmpa    fly1_y
                beq    hog_flag_chk
                cmpa    fly4_y
                beq    hog_flag_chk
                lda     hog4_y
                cmpa    fly1_y
                beq    hog_flag_chk
                cmpa    fly4_y
                beq    hog_flag_chk
                lda     hog1_y
                cmpa    fly1_y
                bhi     hog_check1y
                blo     hog_check2y
hog_check1y     cmpa    fly4_y
                blo    hog_flag_chk
                rts
hog_check2y     lda     hog4_y
                cmpa    fly1_y
                bhi    hog_flag_chk
return5         rts

hog_flag_chk    lda     hog_flag
                cmpa    #0
                bhi    return5
                bra     xclrbyte_hog

;****************************************SCORE AND JARO'BUGS CODE*********************************************

xclrbyte_bob    jsr     [$a000]             ;added 01_05_24 checks if P is held down when bug is collected. If it is then the game type is set to 3 (practice mode)
                cmpa    #$50
                beq     practice
backtobugs      lda     bob_score
                adda    #$1
                sta     bob_score
                bcs     bob_roll
                inc     player1_jar_map
                lda     game_type
                cmpa    #2
                bne     jarobugs_bob
                lbeq    jarobugs_bob2

practice        lda     #1                  ;01_05_24
                cmpa    player1_level           
                bne     backtobugs              
                cmpa    game_type
                bne     backtobugs
                lda     bug_counter2        ;redone 04_05_24 to add different speeds depending on bug picked up
                cmpa    #5
                bls     practice_blue
                cmpa    #9
                bls     practice_yellow
                cmpa    #13
                bls     practice_red

practice_blue   lda #4
                sta plr1_speed
                lbra    practice_code

practice_yellow lda #3
                sta plr1_speed
                lbra practice_code

practice_red    lda #2
                sta plr1_speed
                lbra practice_code

xclrbyte_hog    lda     hog_score
                adda    #$1
                sta     hog_score    
                lbra    jarobugs_hog

bob_roll        lda     bob_rollover
                adda    #$1
                sta     bob_rollover
                lbra    xclrbyte

jarobugs_bob    lda     #1
                sta     bob_beep_flag
                ldx     bob_jar_pos             ;position of bug in jar in a 2 player game
                lda     bug_counter2            ;counter determines colour of bug displayed
                cmpa    #5
                blo     blueguy
                cmpa    #9
                blo     yellowguy
                ldu     #firefly_red_tbl
                lda     #15                      ;flag for red return and points awarded for redbug id
                ldb     player1_jar_map         ;counter that runs in parallel to points to determine bug placement in jar
                cmpb    #$4
                bls     bugline1_score          ;jar top line
                cmpb    #$8
                bls     bugline2_score          ;jar second line
                cmpb    #$0c
                bls     bugline3_score          ;jar third line
                adda    bugline4                
                sta     bugline4                ;add and store to line 4
redreturn       ldb     #8 
                lbra    placebug                ;branch to bug in jar position code then draw bug code

blueguy         ldu     #firefly_blue_tbl       ;if blue bug collected it's processed here
                lda     #2                      ;flag for blue return and points awarded for blue bug id
                ldb     player1_jar_map
                cmpb    #$4
                bls     bugline1_score
                cmpb    #$8
                bls     bugline2_score
                cmpb    #$0c
                bls     bugline3_score
                adda    bugline4
                sta     bugline4
bluereturn      ldb     #8             
                bra     placebug                ;branch to bug in jar position code then draw bug code

yellowguy       ldu     #firefly_yellow_tbl     ;if blue bug collected it's processed here
                lda     #$8                     ;flag for yellow return and points awarded for yellow bug id
                ldb     player1_jar_map
                cmpb    #$4
                bls     bugline1_score
                cmpb    #$8
                bls     bugline2_score
                cmpb    #$0c
                bls     bugline3_score
                adda    bugline4
                sta     bugline4
yellowreturn    ldb     #8             
                bra     placebug                ;branch to bug in jar position code then draw bug code

bugline1_score  pshs    a                       ;add and store to line 1
                adda    bugline1                ;push a to the stack (we'll need this value later) then add bugline1 to it 
                sta     bugline1                ;store the result of the addition to bugline1
                puls    a                       ;get the original value that was in a back to see what branch to take below
                cmpa    #2
                beq     bluereturn
                cmpa    #8
                beq     yellowreturn
                cmpa    #15
                beq     redreturn

bugline2_score  pshs    a                       ;add and store to line 2
                adda    bugline2
                sta     bugline2
                puls    a                
                cmpa    #2
                beq     bluereturn
                cmpa    #8
                beq     yellowreturn
                cmpa    #15
                beq     redreturn

bugline3_score  pshs    a                       ;add and store to line 3
                adda    bugline3
                sta     bugline3
                puls    a
                cmpa    #2
                beq     bluereturn
                cmpa    #8
                beq     yellowreturn
                cmpa    #15
                beq     redreturn

jarobugs_bob2   lda     #1
                sta     bob_beep_flag
                ldx     bob_jar_pos
                ldb     #8
                ldu     #firefly_blue_tbl
placebug        lbsr    draw1
                ldx     bob_jar_pos
                lda     player1_jar_map
                cmpa    #$4
                beq     down_line_bob
                cmpa    #$8
                beq     down_line_bob
                cmpa    #$0c
                beq     down_line_bob
                cmpa    #$10
                beq     game_type_win                ;01_05_24 to try to fix a problem I'm adding an extra label. did branch to bob_wins
                leax    3,x
backfromdown_bob stx     bob_jar_pos
                 lbra    xclrbyte

down_line_bob   leax    $137,x
                bra     backfromdown_bob

game_type_win   lda game_type                       ;added 01_05_24 to select ending depending on one of 3 game types
                cmpa    #1
                beq bob_1p_levels
                cmpa    #2
                beq    bob_wins
                cmpa    #3
                lbeq practice_codel                  ;add new code here for between levels practice game ***maybe*** 04_05_24

bob_wins        clr     bob_flag
                clr     hog_flag
                jsr win_timer
                jsr win_timer
                jsr win_timer
                lbra p2_bob_wins_code

win_timer       lda #4
flash           lbsr winclr                         ;This section of code controls the game screen flash speed at the end of a 2 player game
                ldx #$ffff                          ;changed from $ffff
deminish        leax -1,x
                bne deminish
                pshs a
                jsr movement
                jsr hog_movement
                jsr lineleft
                jsr lineright
                ldx #$ffff                          ;changed from $ffff
deminish3       leax -1,x
                bne deminish3
                puls a
                rts

;*********************CODE TO CALCULATE BONUS POINTS STARTS HERE********************
bob_1p_levels   lda #3                   ;01_05_24
                cmpa game_type
                lbeq practice_codel             ;go to practice_code but dont clear score
                inc player1_level
                lda bugline1                    ;At the end of each level we jump here. Load the value of each line to a
                adda bonus_calc                 ;and add them all together
                sta bonus_calc
                lda bugline2                    
                adda bonus_calc
                sta bonus_calc
                lda bugline3
                adda bonus_calc
                sta bonus_calc
                lda bugline4                   
                adda bonus_calc
                sta bonus_calc
                lda bonus_calc                  ;compare them to see
                cmpa #32                        ;if the entire block is blue
                lbeq blue_block_code
                cmpa #128                       ;yellow
                lbeq yellow_block_code
                cmpa #240                       ;or red
                lbeq red_block_code             ;if they are the text will take care of the rest...

cont_bonus_chk  lda bugline1
                cmpa #8
                beq store_blue1                 ;if the line is all blue store it here
                cmpa #32
                beq store_yellow1               ;if it's all yellow it goes here
                cmpa #60
                beq store_red1                  ;all red goes here

lineofbugs2     lda bugline2
                cmpa #8
                beq store_blue2                  ;if the line is all blue store it here
                cmpa #32
                beq store_yellow2                ;if it's all yellow it goes here
                cmpa #60
                beq store_red2                   ;all red goes here

lineofbugs3     lda bugline3
                cmpa #8
                beq store_blue3                  ;if the line is all blue store it here
                cmpa #32
                beq store_yellow3                ;if it's all yellow it goes here
                cmpa #60
                beq store_red3                   ;all red goes here

lineofbugs4     lda bugline4
                cmpa #8
                beq store_blue4                  ;if the line is all blue store it here
                cmpa #32
                beq store_yellow4                ;if it's all yellow it goes here
                cmpa #60
                beq store_red4                   ;all red goes here

                lbra colour_line_code            ;Test if line code works 19/04/24



store_blue1     inc blue_total_line
                bra lineofbugs2

store_blue2     inc blue_total_line
                bra lineofbugs3

store_blue3     inc blue_total_line
                bra lineofbugs4

store_blue4     inc blue_total_line
                lbra colour_line_code            ;Test if line code works 19/04/24


store_yellow1     inc yellow_total_line
                bra lineofbugs2

store_yellow2     inc yellow_total_line
                bra lineofbugs3

store_yellow3     inc yellow_total_line
                bra lineofbugs4

store_yellow4   inc yellow_total_line
                ;lbra next_level
                lbra colour_line_code            ;Test if line code works 19/04/24


store_red1     inc red_total_line
               bra lineofbugs2

store_red2     inc red_total_line
               bra lineofbugs3

store_red3     inc red_total_line
               bra lineofbugs4

store_red4     inc red_total_line

                lbra colour_line_code            ;Test if line code works 19/04/24



full_blue_blk   inc full_blue                   ;I don't know why I did this???, look at removing it
                bra cont_bonus_chk

full_yellow_blk inc full_yellow
                bra cont_bonus_chk

full_red_blk    inc full_red
                lbra cont_bonus_chk          

jarobugs_hog    jsr     beep_hog
                ldx     hog_jar_pos
                ldb     #8
                ldu     #firefly_yellow_tbl
                lbsr    draw1b
                ldx     hog_jar_pos
                lda     hog_score
                cmpa    #4
                beq     down_line_hog
                cmpa    #8
                beq     down_line_hog
                cmpa    #$0c
                beq     down_line_hog
                cmpa    #$10
                beq     hog_wins           
                leax    -3,x
backfromdown_hog stx    hog_jar_pos
                lbra   xclrbyte

down_line_hog   leax    $149,x
                bra     backfromdown_hog

hog_wins        clr bob_flag
                clr hog_flag
                jsr win_timer
                jsr win_timer
                jsr win_timer
                lbra p2_hog_wins_code

winclr          clra
                clrb
                ldx     #$a00
winclr2         std     ,x++
                cmpx    #$1c40          ;was #$2200
                blo     winclr2
                rts

leftlinecheck   ldx lineleft_master                                 ;Collision checks with left line start here
                cmpx    #$9ff                       ;!!!!!!!!!NOT SO SURE WAS $5ff
                bhi     left_greater1
                clr     linelefttop_y
                bra     left_cont1

left_greater1   jsr opening_pos
                sta linelefttop_y

left_cont1      ldx lineleft_slave
                cmpx    #$9ff                       ;!!!!!!!!!NOT SO SURE WAS $5ff
                bhi     left_greater2
                clr     lineleftbottom_y
                rts                

left_greater2   jsr opening_pos
                sta lineleftbottom_y
                rts

left_bob_hog_check  jsr left_cont2_bob
                    jsr left_cont2_hog
                    rts

left_cont2_bob  lda bob_flag
                cmpa #0
                bhi bob_out_timer
                lda lineleft_x
                cmpa    bob1_x                
                beq check_y_bob
                cmpa    bob4_x
                beq check_y_bob
                bhi     checkx1_bob
                cmpa    bob4_x
                blo     checkx2_bob
                rts
 
checkx1_bob     cmpa    bob4_x
                blo check_y_bob
                rts

checkx2_bob     cmpa    bob1_x
                bhi check_y_bob
                rts

check_y_bob     lda bob1_y
                cmpa bob4_y
                lbhi paused_bob              ;hack added 23/04/24
                lda bob4_y
                cmpa    #8
                blo     offscreenleft_bob
rtnleft_bob     jsr leftlinecheck
                lda linelefttop_y           
                cmpa    bob1_y
                lbhs     paused_bob
                lda lineleftbottom_y
                cmpa    bob4_y
                lbls     paused_bob
                rts

offscreenleft_bob   lda     lineleft_x
                cmpa    bob1_x
                lbeq     paused_bob
                cmpa    bob4_x
                lbeq     paused_bob
                bra     rtnleft_bob

bob_out_timer   lda     #1
                sta     bob_flag
                inc     bob_2p_counter
                lda     bob_2p_counter
                cmpa    #30                        ;time Bob stays invisible when transporter hit
                bhi     bob_back
                rts
bob_back        ldb     #2
                stb     bob_flag
                cmpa    #60                        ;time Bob is invunerable after return
                bhi     bob_full_back
                rts
bob_full_back   clr     bob_flag
                clr     bob_2p_counter
                ;ldx     position                   ;commented out 08_05_24
                ;jsr     opening_pos                 ;at times after Bob reappeared his y position markers were off, to correct this I shoehorned in this fix
                ;cmpa    #$90                        ;to recalculate his position using the transporter opening y position routine. 
                ;bhi     fix_bob_y                   ;but I still had to correct the correction from time to time if it's value was above $90 by removing $70
;bob_back_fixed  sta     bob1_y                      ;the same fix was also applied to Hog.
                rts

;fix_bob_y       suba    #$70                       ;commented out 08_05_24
 ;               bra bob_back_fixed
             
left_cont2_hog  lda hog_flag                        
                cmpa #0
                lbhi hog_out_timer 
                lda lineleft_x
                cmpa    hog1_x                
                beq check_y_hog
                cmpa    hog4_x
                beq check_y_hog
                bhi     checkx1_hog
                cmpa    hog4_x
                blo     checkx2_hog
                rts
 
checkx1_hog cmpa    hog4_x
                blo check_y_hog
                rts

checkx2_hog     cmpa    hog1_x
                bhi check_y_hog
                rts

check_y_hog     lda hog1_y
                cmpa hog4_y
                bhi paused_hog              ;hack added 23/04/24
                lda hog4_y
                cmpa    #8
                blo     offscreenleft_hog
rtnleft_hog     jsr leftlinecheck
                lda linelefttop_y
                cmpa    hog1_y
                bhs     paused_hog
                lda lineleftbottom_y
                cmpa    hog4_y
                bls     paused_hog
                rts

offscreenleft_hog   lda     lineleft_x
                cmpa    hog1_x
                beq     paused_hog
                cmpa    hog4_x
                beq     paused_hog
                bra     rtnleft_hog

hog_out_timer   lda     #1
                sta     hog_flag
                inc     hog_2p_counter
                lda     hog_2p_counter
                cmpa    #30                        ;time hog's invisable after he touches a beam
                bhi     hog_back
                rts
hog_back        ldb     #2
                stb     hog_flag
                cmpa    #60                        ;time hog can't pickup flies after his return
                bhi     hog_full_back
                rts
hog_full_back   clr     hog_flag
                clr     hog_2p_counter
                ;ldx     hog_position
                ;jsr     opening_pos
                ;cmpa    #$90
                ;bhi     fix_hog_y
;hog_back_fixed  sta     hog1_y 
                rts

;fix_hog_y       suba    #$70
 ;               bra hog_back_fixed

paused_hog      lda game_type                               ;***Take a look at this may be able to go direct to hog_restrict
                cmpa    #2
                beq     hog_restrict     
                lbra reset_game

paused_bob      lda game_type
                cmpa    #2
                beq     bob_restrict    
                lbra end_transport                             ;If single player game branch here  07_03

hog_restrict    lda #1
                sta hog_flag
                jsr hog_jsclear
                rts

bob_restrict    lda #1
                sta bob_flag
                jsr jsclear
                rts

rightlinecheck  ldx lineright_master                            ;Collision checks with right line start here
                cmpx    #$1bff                      ;!!!!!!!!NOT SO SURE WAS $17ff ***1bff
                blo     right_less1
                lda     #144
                sta     linerighttop_y
                bra     right_cont1

right_less1     jsr opening_pos
                cmpa #$90
                bhi little_hack
                sta linerighttop_y
                bra right_cont1

little_hack     lda #0                              ;added to fix bug where transporter hit was registered if passing through red beam opening at top of screen
                sta linerighttop_y

right_cont1     ldx lineright_slave
                cmpx    #$1bff                      ;!!!!!!!!NOT SO SURE WAS $17ff
                blo     right_less2
                lda     #144
                sta     linerightbottom_y
                rts

right_less2     jsr opening_pos
                sta linerightbottom_y
                rts

right_bob_hog_check jsr right_cont2_bob
                    jsr right_cont2_hog
                    rts

right_cont2_bob lda bob_flag
                cmpa #0
                bhi return6
                lda lineright_x
                cmpa    bob1_x                
                beq checkyright_bob
                cmpa    bob4_x
                beq checkyright_bob
                bhi     checkxright1_bob
                cmpa    bob4_x
                blo     checkxright2_bob
                rts
 
checkxright1_bob cmpa    bob4_x
                blo checkyright_bob
                rts

checkxright2_bob cmpa    bob1_x
                bhi checkyright_bob
                rts

checkyright_bob lda bob1_y
                cmpa bob4_y
                bhi paused_bob              ;hack added 23/04/24
                lda bob4_y
                cmpa    #8
                blo     offscreenright_bob
rtnright_bob    jsr     rightlinecheck
                lda linerighttop_y
                cmpa    bob1_y
                lbhs     paused_bob
                lda linerightbottom_y
                cmpa    bob4_y
                lbls     paused_bob
return6         rts

offscreenright_bob  lda     lineright_x
                cmpa    bob1_x
                lbeq     paused_bob
                cmpa    bob4_x
                lbeq     paused_bob
                bra     rtnright_bob

right_cont2_hog lda hog_flag
                cmpa #0
                bhi return6
                lda lineright_x
                cmpa    hog1_x                
                beq checkyright_hog
                cmpa    hog4_x
                beq checkyright_hog
                bhi     checkxright1_hog
                cmpa    hog4_x
                blo     checkxright2_hog
                rts
 
checkxright1_hog cmpa    hog4_x
                blo checkyright_hog
                rts

checkxright2_hog cmpa    hog1_x
                bhi checkyright_hog
                rts

checkyright_hog lda hog1_y
                cmpa hog4_y
                lbhi paused_hog              ;hack added 23/04/24
                lda hog4_y
                cmpa    #8
                blo     offscreenright_hog
rtnright_hog    jsr     rightlinecheck
                lda linerighttop_y
                cmpa    hog1_y
                lbhs     paused_hog
                lda linerightbottom_y
                cmpa    hog4_y
                lbls     paused_hog
                rts

offscreenright_hog  lda     lineright_x
                cmpa    hog1_x
                lbeq     paused_hog
                cmpa    hog4_x
                lbeq     paused_hog
                bra     rtnright_hog

opening_pos     clra                ;code to find transporter openings y coordinates
                clrb                
                leax    -$9e0,x     ;changed from-$a00 26/04/24
                leax    -$20,x      ;Added 04_05_24 to fix a collision dectection problem found
divideagn       leax    -32,x       ;we remove 32 from X , effectly dividing by 32
                inca                ;and add one to A
                cmpx    #31         ;is x below 32?
                bhi     divideagn   ;if not run again
                rts

;**********************************************************************************************************************************************************                                                                               
;********************************************************CODE FOR LEFT LINE STARTS HERE********************************************************************

leftline_reset  ldb     #4                      ;This resets the length counter of the top part of the left transporter, 1 is loaded to b
                stb     lineleft_counter        ; and saved to the counter
                rts

lineleft        ldx     lineleft_pos            ;Position of left transporter loaded into x
                lbra    __chkline1              ;branch to chkline1

r_chkline1      lda     lineleft_pixel          ;load the pixel position (within the byte) to a
                ldb     lineleft_counter        ;load the top line counter to b

line1           cmpx    #$1bff                  ;first before drawing anything make sure that the screen buffer is less than $1840
                bhi     test1                   ;if its higher than $1840 branch to test1
                sta     ,x                      ;start or continue drawing top part of left line, the pixel stored in a is placed in x
                leax    $20,x                   ;increase x by $20 (brings us to the next line directly under the last pixel drawn
                decb                            ;reduce the value in b by 1
                bne     line1                   ;check if b is 0, if it's not go back to line1 and draw again

test1           stx     lineleft_master
                leax    $380,x                  ; then add $280 to it
                pshs    a
                lda     player1_level
                cmpa    #3
                lbls    add
                cmpa    #5
                lbeq    add
                cmpa    #6
                lbeq    add
                cmpa    #7
                lbeq    add
                cmpa    #10
                lbeq    add
                cmpa    #11
                lbeq    add
                cmpa    #12
                lbeq    add
                cmpa    #15
                lbeq    add
                cmpa    #16
                lbeq    add
                cmpa    #17
                lbeq    add               
                puls    a
added           cmpx    #$1bff
                bhs     thingy
                stx     lineleft_slave          ;and store it to lineleft_slave (the second part of the lines starting position)
after_thing     leax    -$380,x                 ;now remove the $280 so we start the blank from the last drawn pixel of the top line
                pshs    a
                lda     player1_level
                cmpa    #3
                lbls    sub
                cmpa    #5
                lbeq    sub
                cmpa    #6
                lbeq    sub
                cmpa    #7
                lbeq    sub
                cmpa    #10
                lbeq    sub
                cmpa    #11
                lbeq    sub
                cmpa    #12
                lbeq    sub
                cmpa    #15
                lbeq    sub
                cmpa    #16
                lbeq    sub
                cmpa    #17
                lbeq    sub 
                puls    a
subed
blank_check     leax    $20,x                   ;jump down one line
                cmpx    lineleft_slave          ;compare the current address of y with the value we stored earlier    
                blo     blank_check             ;if it's not that value yet jump back to blank_check

line2           cmpx    #$1bff                  ;straight away, before drawing anything, check to see that the screen address stored in y is not more than $1840
                bhi     get_out                 ;if it is branch to get_out
                sta     ,x                      ;otherwise store the pixel value in a to the screen address in y
                leax    $20,x                   ;increase the value in y by $20 (just below the last pixel byte drawn)
                cmpx    #$1bff                  ;and compare it to $1840
                blo     line2                   ;if it's value is lower go back to line2 and continue drawing

get_out         rts                             ;returns us to where we were in the the main_loop before we started with the left line

thingy          ldy     #$2201                  ;I'm pretty sure this is code that I added after finding that the start of the slave line was erasing
                sty     lineleft_slave          ;parts of the jaroflies at the base of the screen. it basicaly stores the slave line start point to
                bra     after_thing             ;$1fff if it's greater than $17ff which is a bit hackey but it works, just dont write any code to $1fff ;)

lineleftclr     ldx     lineleft_pos            ;load the position of the left line to x 
                lda     #%00000000              ;load a with the clear byte (background colour)
                ldb     lineleft_counter        ;load b with the lineleft_counter value
line1c          cmpx    #$1c00                  ;Here we mirror what was done to draw the line above, compare the address in x to $1840
                bhi     test2                   ;if it's higher branch to test2
                sta     ,x                      ;otherwise store the value in a (green, background colour) to the screen location in x
                leax    $20,x                   ;increase x by $20, moving directly below the last byte drawn
                decb                            ;decrease the value in leftline_counter by 1
                bne     line1c                  ;if the value in b is not yet 0 go back to line1c

test2           ldx     lineleft_slave          ;load the start address of the second part of the line (after blank, which we worked out earlier) to y

line2c          sta     ,x                      ;store the byte in a to y
                leax    $20,x                   ;increase the value of y by $20, directly below the last byte drawn
                cmpx    #$1c00                  ;then compare y to $1840
                blo     line2c                  ;if the value in y is less than $1840 branch back to line2c and keep going
                bra     __change                ;branch to the code that moves the pixel one place to the right in the byte, or resets it back to the left.

b_change        ldx     lineleft_slave          ;load the second part of the lines previous start position into y
                leax    $80,x                   ;increase it in line with the increase in lineleft_counter made below ($20 increase for each incb) 
                stx     lineleft_slave          ;save it back to lineleft_slave
                ldb     lineleft_counter        ;load the previous counter value (for length of first part of line) into b
                addb    #4                      ;increase it's value in proportion to the leay made for lineleft_slave above (one incb for each multiple of $20)
                                                ;the more there are the more quickly the line will move vertically                            
                stb     lineleft_counter        ;store the value in a to lineleft_counter 
                ldb     lineleft_counter     
                cmpb    line_length             ;compare the value in b to max length of line a      
                lbhi    leftline_reset          ;if the value is greater branch to lineleft_reset to make it 1 again

                rts

__change        lda     lineleft_pixel          ;load the current pixel value to a           
                cmpa    #2                      ;compare its value to 2 (here we're checking if the pixel is all the way to the right ie. %00000010)
                beq     move_byte               ;if it is branch to move_byte
                rora                            ;logic operation roll to right. example: makes %10000000 become %01000000
                rora                            ;done again to shift the two places in total
                sta     lineleft_pixel          ;store the twice right shifted value to lineleft_pixel
                inc     lineleft_x               
                bra     b_change                ;then branch to b_change
        
move_byte       ldx     lineleft_pos            ;load lineleft_pos to x
                leax    $1,x                    ;increase it by 1 (effectly moving the position one byte to the right)
                stx     lineleft_pos            ;save the increased value to lineleft_pos
                ldx     lineleft_slave          ;load lineleft_slave to y (the starting position of the second part of the line)
                leax    $1,x                    ;increase it by 1 (effectly moving the position one byte to the right)
                stx     lineleft_slave          ;save the increased value to lineleft_slave
                inc     lineleft_x
                lda     #%10000000              ;load pixel start at left value into a
                sta     lineleft_pixel          ;then store it to lineleft_pixel
                lbra    r_chkline1              ;branch to r_chkline1   

__chkline1      cmpx    #$21f                   ;compare the value in x to $21f (extreme right side of screen)
                bhi     reseta                  ; and jump to reseta if it has (to bring it back to $200)
                lbra    r_chkline1              ;if x is not $21f branch on over to r_chkline1

reseta          ldx     #$200                   ;put $200 into x (address for top left of screen)
                stx     lineleft_pos            ;and store it to the left transporters position address
                lda     #1
                sta     lineleft_x
                lbra    r_chkline1              ;then branch to r_chkline1

add     leax $200,x
        puls a
        lbra added

sub     leax -$200,x
        puls a
        lbra subed

;**********************************************************************************************************************************************************                                                                               
;********************************************************CODE FOR RIGHT LINE STARTS HERE*******************************************************************
    
rightline_reset     ldb     line_length                  ;This resets the length counter of the top part of the left transporter, 1 is loaded to b ***was line_length***
                    stb     lineright_counter   ; and saved to the counter
                    rts

lineright           ldx     lineright_pos       ;Position of left transporter loaded into x
                    lbra    right_chkline       ;branch to chkline1

right_chkline1      lda     lineright_pixel     ;load the pixel position (within the byte) to a
                    ldb     lineright_counter   ;load the top line counter to b

rightline1          cmpx    #$1bff              ;first before drawing anything make sure that the screen buffer is less than $1600
                    bhi     righttest1          ;if its higher than $1600 branch to test1
                    sta     ,x                  ;start or continue drawing top part of left line, the pixel stored in a is placed in x
                    leax    $20,x               ;increase x by $20 (brings us to the next line directly under the last pixel drawn
                    decb                        ;reduce the value in b by 1
                    bne     rightline1          ;check if b is 0, if it's not go back to line1 and draw again

righttest1          stx     lineright_master
                    leax    $380,x              ; then add $280 to it
                    pshs    a
                    lda     player1_level
                    cmpa    #3
                    lbls    addr
                    cmpa    #5
                    lbeq    addr
                    cmpa    #6
                    lbeq    addr
                    cmpa    #7
                    lbeq    addr
                    cmpa    #10
                    lbeq    addr
                    cmpa    #11
                    lbeq    addr
                    cmpa    #12
                    lbeq    addr
                    cmpa    #15
                    lbeq    addr
                    cmpa    #16
                    lbeq    addr
                    cmpa    #17
                    lbeq    addr 
                    puls    a
addedr              cmpx    #$1bff
                    bhi     thingy_right
                    stx     lineright_slave     ;and store it to lineleft_slave (the second part of the lines starting position)
after_thing_right   leax    -$380,x             ;now remove the $280 so we start the blank from the last drawn pixel of the top line
                    pshs    a
                    lda     player1_level
                    cmpa    #3
                    lbls    subr
                    cmpa    #5
                    lbeq    subr
                    cmpa    #6
                    lbeq    subr
                    cmpa    #7
                    lbeq    subr
                    cmpa    #10
                    lbeq    subr
                    cmpa    #11
                    lbeq    subr
                    cmpa    #12
                    lbeq    subr
                    cmpa    #15
                    lbeq    subr
                    cmpa    #16
                    lbeq    subr
                    cmpa    #17
                    lbeq    subr
                    puls    a

right_blank_check   leax    $20,x               ;jump down one line
                    cmpx    lineright_slave     ;compare the current address of y with the value we stored earlier    
                    blo     right_blank_check   ;if it's not that value yet jump back to blank_check

rightline2          cmpx    #$1bff              ;straight away, before drawing anything, check to see that the screen address stored in y is not more than $1840
                    bhi     get_out_right       ;if it is branch to get_out
                    sta     ,x                  ;otherwise store the pixel value in a to the screen address in y
                    leax    $20,x               ;increase the value in y by $20 (just below the last pixel byte drawn)
                    cmpx    #$1bff              ;and compare it to $1840
                    bls     rightline2          ;if it's value is lower go back to line2 and continue drawing

get_out_right       rts                         ;returns us to where we were in the the main_loop before we started with the left line

thingy_right        ldy     #$2201                ;save to zeropage ??? was #$2201
                    sty     lineright_slave
                    bra     after_thing_right

linerightclr        ldx     lineright_pos       ;load the position of the left line to x 
                    lda     #%00000000          ;load a with the clear byte (background colour)
                    ldb     lineright_counter   ;load b with the lineleft_counter value
rightline1c         cmpx    #$1c00              ;Here we mirror what was done to draw the line above, compare the address in x to $1840
                    bhi     righttest2          ;if it's higher branch to test2
                    sta     ,x                  ;otherwise store the value in a (green, background colour) to the screen location in x
                    leax    $20,x               ;increase x by $20, moving directly below the last byte drawn
                    decb                        ;decrease the value in leftline_counter by 1
                    bne     rightline1c         ;if the value in b is not yet 0 go back to line1c

righttest2          ldx     lineright_slave     ;load the start address of the second part of the line (after blank, which we worked out earlier) to y

rightline2c         sta     ,x                  ;store the byte in a to y
                    leax    $20,x               ;increase the value of y by $20, directly below the last byte drawn
                    cmpx    #$1c00              ;then compare y to $1840
                    blo     rightline2c         ;if the value in y is less than $1840 branch back to line2c and keep going
                    bra     right_change        ;branch to the code that moves the pixel one place to the right in the byte, or resets it back to the left.

rightb_change       ldx     lineright_slave     ;load the second part of the lines previous start position into y
                    leax    $80,x               ;increase it in line with the increase in lineleft_counter made below ($20 increase for each incb) 
                    stx     lineright_slave     ;save it back to lineleft_slave

                    ldb     lineright_counter   ;load the previous counter value (for length of first part of line) into b
                    subb    #4                  ;increase it's value in proportion to the leay made for lineleft_slave above (one incb for each multiple of $20)
                                                ;the more there are the more quickly the line will move vertically                            
                    stb     lineright_counter   ;store the value in a to lineleft_counter
                                                ;PUT LINE Y POSITION COLLISION STUFF HERE*************************** 
                    ldb     lineright_counter       
                    cmpb    #4         ;compare the value in b to max length of line a    was set to ******#4******  
                    lbls    rightline_reset     ;if the value is greater branch to lineleft_reset to make it 1 again

                    rts

right_change        lda     lineright_pixel     ;load the current pixel value to a
                    cmpa    #192                ;compare its value to 2 (here we're checking if the pixel is all the way to the right ie. %00000010)
                    beq     right_move_byte     ;if it is branch to move_byte
                    lsla                        ;logic operation roll to right. example: makes %10000000 become %01000000
                    lsla                        ;done again to shift the two places in total
                    sta     lineright_pixel     ;store the twice right shifted value to lineleft_pixel
                    dec     lineright_x         ;****************************************************************************************
                    bra     rightb_change       ;then branch to b_change
        
right_move_byte     ldx     lineright_pos       ;load lineleft_pos to x
                    leax    -$1,x               ;increase it by 1 (effectly moving the position one byte to the right)
                    stx     lineright_pos       ;save the increased value to lineleft_pos

                    ldx     lineright_slave     ;load lineleft_slave to y (the starting position of the second part of the line)
                    leax    -$1,x               ;increase it by 1 (effectly moving the position one byte to the right)
                    stx     lineright_slave     ;save the increased value to lineleft_slave

                    dec     lineright_x         

                    lda     #%00000011          ;load pixel start at left value into a
                    sta     lineright_pixel     ;then store it to lineleft_pixel
                    lbra    right_chkline1      ;branch to r_chkline1   

right_chkline       cmpx    #$200               ;compare the value in x to $21f (extreme right side of screen)
                    blo     right_reseta        ; and jump to reseta if it has (to bring it back to $200)
                    lbra    right_chkline1      ;if x is not $21f branch on over to r_chkline1

right_reseta        ldx     #$21f               ;put $200 into x (address for top left of screen)
                    stx     lineright_pos       ;and store it to the left transporters position address
                    lda     #128                ;****************************************************************************************
                    sta     lineright_x         ;****************************************************************************************           
                    lbra    right_chkline1      ;then branch to r_chkline1

addr    leax $200,x
        puls a
        lbra addedr

subr    leax -$200,x
        puls a
        lbra right_blank_check
                    
;***********************************************************************************************************************************************************
;*****************************************************THIS IS WHERE THE FIREFLY CODE BEGINS*****************************************************************
xtime_2plr      ldx bug_rndpos
                cmpx    #1
                blo     xgetrnd
                inc     bug_counter1    ;Load the value in $700 into Y
                lda     bug_counter1
                cmpa    #16             ;check if the value in Y is $FFFF
                beq     times_2plr      ;If it is branch to "times"
                lblo    red_bug 
                rts
               
times_2plr      clr     bug_counter1    ;Set $700 back to 0 (this may not be needed)
                bra     xtime_2plr

xtime           lda     #%00000000
                ldx bug_rndpos
                cmpx    #1
                blo     xgetrnd
                inc     bug_counter1    ;Load the value in $700 into Y
                lda     bug_counter1
                cmpa    #36        ;check if the value in Y is $FFFF
                beq     times           ;If it is branch to "times"
                lda     bug_counter2    ;load $702 (second time counter) into Y
                cmpa    #5              ;compare it's value to 0
                lblo    blue_bug        ;if it's 0 branch to xcola
                cmpa    #9             ;Compare Y to 3
                lblo    yellow_bug      ;if it's 3 branch to colb
                cmpa    #13             ;Compare Y to 6
                lblo    red_bug         ;if it's 6 branch to colc
                cmpa    #13             ;Compare Y to 9
                lbeq    bug_explode       ;if it's 9 branch to xclrbyte                  *************Put Bug Explode animation jump here**********
                rts
               
times           clr     bug_counter1    ;Set $700 back to 0 (this may not be needed)
                inc     bug_counter2    ;Load value of address $702 into Y
                bra     xtime

xgetrnd         jsr     $bf3b           ;Jump to memory address $BF3B (this is where Color Basic's rnd function lives) It will put a random number into X
                tfr     x,d             ;X now contains a 16 bit random number, move it to D so we can work with it 
                andb    #%01111111      ;D is a combination of A and B so we "and" the values in both the A and B registers 
                anda    #%00011111     ;so that D contains a number between 1 and 1535 ($5ff) (I dont think I did this part right, it could probably be much better)
                tfr     d,x             ;After screwing around with D put it back in X
                cmpx    #$a20          ;We want a number we can use as an address in the screen buffer. Something between $400 and $5FF. So first compare it to $400
                blo     xgetrnd         ;if the number is lower than $400 disgard it and go get another number, if its higher go to the next line
                cmpx    #$1b00          ;Now we compare our random number to $5FF
                bhi     xgetrnd         ;if its larger than $5FF (it shouldn't be) throw it away and go get another. If not, great, move to the next line
                tfr     x,d

;****The followong code was provided by MRDAVE6309. It's way more effecient than my brute force remove all $XXFF code :)****

                tfr     b,a             ;Make copy of b
                andb    #$0f            ;remove upper nibble
                cmpb    #$0f
                bne     skip
                anda    #$f0            ;check upper nibble
                cmpa    #0
                bne     xgetrnd

;******************Dave's code mod ends here**************************************************************************

skip            stx    bug_rndpos
                jsr    bug_xy        
                lbra   xtime

blue_bug        jsr    initial_clear

                lda    bug_counter1
                cmpa   #9
                bhi    two
one             ldb    #8
                ldx    bug_rndpos
                ldu    #firefly_blue_tbl
draw1           lda    ,u+
                sta    ,x+
                lda    ,u+
                sta    ,x
                leax   31,x
                leau   4,u
                decb
                bne    draw1
                rts

two             lda    bug_counter1
                cmpa   #18
                bhi    three
                ldb    #8
                ldu    #firefly_blue_tbl
                ldx    bug_rndpos
                leax   -$40,x
                leau   2,u 
draw2           lda    ,u+
                sta    ,x+
                lda    ,u+
                sta    ,x
                leax   31,x
                leau   4,u
                decb
                bne    draw2
                rts

three           lda    bug_counter1
                cmpa   #27
                bhi    four
                ldb    #8
                ldu    #firefly_blue_tbl
                ldx    bug_rndpos
                leax   -$40,x
                leau   4,u 
draw3           lda    ,u+
                sta    ,x+
                lda    ,u+
                sta    ,x
                leax   31,x
                leau   4,u
                decb
                bne    draw3
                rts
                
four            ldb     #8
                ldu     #firefly_blue_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    2,u 
draw4           lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw4
              
                lda     bug_counter2
                cmpa    #5
                beq     maybeclr
                rts

maybeclr        lda     bug_counter1
                cmpa    #35
                blo     back
                lda     #%00000000
                ldx     bug_rndpos
                ldb     #8
clear_ok        sta     ,x+
                sta     ,x
                leax    31,x
                decb
                bne     clear_ok

back            rts

yellow_bug      jsr     initial_clear

                lda     bug_counter1
                cmpa    #9
                bhi     twob
oneb            ldb     #8
                ldx     bug_rndpos
                ldu     #firefly_yellow_tbl
draw1b          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw1b
                rts

twob            lda     bug_counter1
                cmpa    #18
                bhi     threeb
                ldb     #8
                ldu     #firefly_yellow_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    2,u 
draw2b          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw2b
                rts

threeb          lda     bug_counter1
                cmpa    #27
                bhi     fourb
                ldb     #8
                ldu     #firefly_yellow_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    4,u 
draw3b          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw3b
                rts
                
fourb           ldb     #8
                ldu     #firefly_yellow_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    2,u 
draw4b          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw4b
              
                lda     bug_counter2
                cmpa    #11
                lbeq     maybeclr
                rts

red_bug         jsr     initial_clear

                lda     bug_counter1
                cmpa    red1
                bhi     twoc
onec            ldb     #8
                ldx     bug_rndpos
                ldu     #firefly_red_tbl
draw1c          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw1c
                rts

twoc            lda     bug_counter1
                cmpa    red2
                bhi     threec
                ldb     #8
                ldu     #firefly_red_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    2,u 
draw2c          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw2c
                rts

threec          lda     bug_counter1
                cmpa    red3
                lbhi     fourc
                ldb     #8
                ldu     #firefly_red_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    4,u 
draw3c          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw3c
                rts
                
fourc           ldb     #8
                ldu     #firefly_red_tbl
                ldx     bug_rndpos
                leax    -$40,x
                leau    2,u 
draw4c          lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    31,x
                leau    4,u
                decb
                bne     draw4c
              
                lda     bug_counter2
                cmpa    #17
                lbeq     maybeclr
                rts

xclrbyte        lda     #0              ;Load the byte code to display a blue shape in a screen byte into A
                ldx     bug_rndpos
                ldb     #8              ;Store the blue shape code we put in A into X (the random number we got that we're using as an address on screen)
               
clr_fly         sta  ,x+                ;This is the point to jump to once a bug and Bob collision takes place (but update the score too)
                sta  ,x
                leax     31,x
                decb
                bne     clr_fly                
                clr     bug_counter1
                clr     bug_counter2
                lbra    xgetrnd

initial_clear   lda     #%00000000
                ldx     bug_rndpos
                ldb     #8
clear           sta     ,x+
                sta     ,x
                leax    31,x
                decb
                bne     clear
                rts

firefly_blue_tbl    fcb     %10000000,%00000010,%00000000,%00000000,%00000000,%00000000         ;blue
                    fcb     %10100000,%00001010,%00000000,%00000000,%00000000,%00000000
                    fcb     %00001000,%00100000,%10101000,%00101010,%00001000,%00100000
                    fcb     %00000010,%10000000,%00000010,%10000000,%10100010,%10001010
                    fcb     %00001010,%10100000,%00001010,%10100000,%10001010,%10100010
                    fcb     %00100010,%10001000,%00100010,%10001000,%00100010,%10001000
                    fcb     %10101010,%10101010,%10101010,%10101010,%10101010,%10101010
                    fcb     %00101000,%00101000,%00101000,%00101000,%00101000,%00101000

  
firefly_yellow_tbl  fcb     %01000000,%00000001,%00000000,%00000000,%00000000,%00000000         ;yellow
                    fcb     %01010000,%00000101,%00000000,%00000000,%00000000,%00000000
                    fcb     %00000100,%00010000,%01010100,%00010101,%00000100,%00010000
                    fcb     %00000001,%01000000,%00000001,%01000000,%01010001,%01000101
                    fcb     %00000101,%01010000,%00000101,%01010000,%01000101,%01010001
                    fcb     %00010001,%01000100,%00010001,%01000100,%00010001,%01000100
                    fcb     %01010101,%01010101,%01010101,%01010101,%01010101,%01010101
                    fcb     %00010100,%00010100,%00010100,%00010100,%00010100,%00010100



firefly_red_tbl     fcb     %11000000,%00000011,%00000000,%00000000,%00000000,%00000000         ;red
                    fcb     %11110000,%00001111,%00000000,%00000000,%00000000,%00000000
                    fcb     %00001100,%00110000,%11111100,%00111111,%00001100,%00110000
                    fcb     %00000011,%11000000,%00000011,%11000000,%11110011,%11001111
                    fcb     %00001111,%11110000,%00001111,%11110000,%11001111,%11110011
                    fcb     %00110011,%11001100,%00110011,%11001100,%00110011,%11001100
                    fcb     %11111111,%11111111,%11111111,%11111111,%11111111,%11111111
                    fcb     %00111100,%00111100,%00111100,%00111100,%00111100,%00111100

;************************************************************************************************************************************************************
;***********************************************************Bob joystick code starting here******************************************************************
joystick        jsr     movement        
                jsr     up_check
                jsr     down_check
                jsr     left_check
                jsr     right_check
                rts

up_check        ;ldb     bob_flag                   ;all this checks for 1 flag then jumps and exits if invisible, tis but shit and causes problems
                ;cmpb    #1                         ;commented out along with its branches 08_05_24
                ;beq     bob_up_flag_chk
bob_up_up       jsr     $a9de
                ldb     $015d
                cmpb    #$0f
                bls     up
                rts

down_check      ;ldb     bob_flag                   ;all this checks for 1 flag then jumps and exits if invisible, tis but shit and causes problems
                ;cmpb    #1                         ;commented out along with its branches 08_05_24
                ;beq     bob_down_flag_chk
bob_down_down   jsr     $a9de
                ldb     $015d
                cmpb    #$29
                lbhs     down
                rts

;bob_up_flag_chk ldb     bob1_y                     ;all this checks for 1 flag then jumps and exits if invisible, tis but shit and causes problems
                ;cmpb    #2
                ;beq    return1
                ;bra     bob_up_up

;bob_down_flag_chk ldb   bob1_y                     ;all this checks for 1 flag then jumps and exits if invisible, tis but shit and causes problems
                ;cmpb    #136
                ;beq    return1
                ;bra     bob_down_down

left_check      ldb     bob1_x
                cmpb    #1
                beq    return1
                jsr     $a9de
                ldb     $015c
                cmpb    #$0f
                lbls     left
                rts

right_check     ldb     bob1_x
                cmpb    #120
                beq    return1
                jsr     $a9de
                ldb     $015c
                cmpb    #$29
                lbhs     right
return1         rts
                
up              jsr     animate_count
                jsr     jsclear
                ldx     position
                leax    -$40,x
                stx     position
                ldb     bob1_y
                subb    #2
                cmpb    #0
                beq     rst_ypos1                  
                stb     bob1_y
                cmpb    #2                          ;is bob1_y 2
                beq     hack_bob_y_top              ;if so branch to set bob4_y to 9
                cmpb    #136
                beq     hack_bob_y_bottom           ;This is a mess, may need to make another section for this
                bra     chky4
ypos_rtn1       jsr     movement
                bra     chky4
rst_ypos1       ldb     #144
                stb     bob1_y
                bra     ypos_rtn1
chky4           ldb     bob4_y
                subb    #2
                cmpb    #1
                blo     rst_ypos4         
                stb     bob4_y
ypos_rtn4       jsr     movement
                rts
rst_ypos4       ldb     #145
                stb     bob4_y
                bra     ypos_rtn4

hack_bob_y_top  ldb     #9
                stb     bob4_y
                bra     ypos_rtn4                    ;this did branch to chky4

down            jsr     animate_count
                jsr     jsclear
                ldx     position
                leax    $40,x
                stx     position
                ldb     bob1_y
                addb    #2
                cmpb    #146
                beq     rst_ypos                    
                stb     bob1_y
                cmpb    #2                          ;is bob1_y 2
                beq     hack_bob_y_top              ;if so branch to set bob4_y to 9
                cmpb    #136                        ;is bob1_y 136
                beq     hack_bob_y_bottom           ;if so branch to set bob4_y to 143
                bra     chky5
ypos_rtn        jsr     movement
                bra     chky5
rst_ypos        ldb     #2
                stb     bob1_y
                bra     ypos_rtn
chky5           ldb     bob4_y
                addb    #2
                cmpb    #145
                bhs     rst_ypos5                   ;BRANCH MAY NEED CHANGING!!!!!!!!!!!!           
                stb     bob4_y
ypos_rtn5       jsr     movement
                rts
rst_ypos5       ldb     #1
                stb     bob4_y
                bra     ypos_rtn5

hack_bob_y_bottom  ldb  #143
                stb     bob4_y
                bra     ypos_rtn5                   ;this did branch to chky5

left            jsr     animate_count
                jsr     jsclear
                ldb     animation
                cmpb    #4           ; **************************************************************************
                blo     onon           ; jmp to "on" if animation is lower than 5, this moves in the byte without increasing the byte address    
                ldx     position
                leax    -1,x
                stx     position
                dec     xpos
onon            inc     animation
                ldb     #2
                stb     direction
                jsr     movement
                rts

right           jsr     animate_count
                jsr     jsclear
                ldb     animation
                cmpb    #4           ; **************************************************************************
                blo     on            ; jmp to "on" if animation is lower than 5, this moves in the byte without increasing the byte address    
                ldx     position
                leax    1,x
                stx     position
                inc     xpos
on              inc     animation
                ldb     #1
                stb     direction
                jsr     movement
                rts

jsclear         ldb     #8
                ldx     position
                lda     #%00000000
clr             cmpx    #$9ff
                lbls     complete_below_c
                cmpx    #$1c00
                lbhs     complete_above_c
                sta     ,x+
                sta     ,x+
                sta     ,x
                leax    30,x
                decb
                bne     clr
                rts

movement        lda     animation
                cmpa     #4                     
                lbhi     reset
                lda     animation
                cmpa    #1
                beq     anim
                cmpa    #2
                beq     anim2
                cmpa    #3
                lbeq     anim3
                cmpa    #4
                lbeq     anim4

anim            ;lda     bob_flag                       ;all this checks for 1 flag then jumps and exits if invisible, tis but shit and causes problems
                ;cmpa    #1                             ;commented out 08_05_24
                ;beq    return              ;07_03
                ldb     #8
                ldx     position
                jsr     direction_chk 
jsdraw          cmpx    #$9ff                   ; if animation is 1 it will continue here
                lbls     complete_below
                cmpx    #$1c00
                lbhs     complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     jsdraw
                lda     bob_flag
                cmpa    #2
                lbeq    set3
return          rts

anim2           ;lda     bob_flag
                ;cmpa    #1
                ;beq    return              ;07_03
                ldb     #8
                ldx     position
                jsr     direction_chk
                leau    3,u
jsdraw2         cmpx    #$9ff
                lbls     complete_below
                cmpx    #$1c00
                lbhs     complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     jsdraw2
                lda     bob_flag
                cmpa    #2
                lbeq    set3
                rts

anim3          ;lda     bob_flag
               ; cmpa    #1
               ; beq    return2              ;07_03
                ldb     #8
                ldx     position   
                jsr     direction_chk
                leau    6,u
jsdraw3         cmpx    #$9ff
                lbls     complete_below
                cmpx    #$1c00
                bhs     complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     jsdraw3
                lda     bob_flag
                cmpa    #2
                lbeq    set3
return2                rts

anim4           ;lda     bob_flag
                ;cmpa    #1
                ;beq    return2              ;07_03
                ldb     #8
                ldx     position   
                jsr     direction_chk
                leau    9,u
jsdraw4         cmpx    #$9ff
                bls     complete_below
                cmpx    #$1c00
                bhs     complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     jsdraw4
                lda     bob_flag
                cmpa    #2
                lbeq    set3
                rts

reset           lda     #1
                sta     animation
                lbra    movement

complete_above      leax    -$1200,x
                    ldy     position
                    leay    -$1200,y
                    sty     position
                    lbra     jsdraw

complete_below      leax    $1200,x
                    ldy     position
                    leay    $1200,y
                    sty     position
                    lbra     jsdraw

complete_above_c    leax    -$1200,x
                    lbra     clr

complete_below_c    leax    $1200,x
                    lbra     clr

direction_chk       lda     direction
                    cmpa    #1
                    bne     direction_chk2
                    lda     anim_counter
                    cmpa    #5
                    bhi     right2
                    lda     bob_flag            ;added to this branch and the 3 below to fix the 2p collision problem 08_05_24
                    cmpa    #1
                    beq     bob_clear
                    cmpa    #3
                    beq     bob_right_hog
                    ldu     #bob_right
                    rts
right2              lda     bob_flag
                    cmpa    #1
                    beq     bob_clear
                    cmpa    #3
                    beq     bob_right2_hog
                    ldu     #bob_right2
                    rts

direction_chk2      lda     anim_counter
                    cmpa    #5
                    bhi     left2
                    lda     bob_flag
                    cmpa    #1
                    beq     bob_clear
                    cmpa    #3
                    beq     bob_left_hog
                    ldu     #bob_left
                    rts
left2               lda     bob_flag
                    cmpa    #1
                    beq     bob_clear
                    cmpa    #3
                    beq     bob_left2_hog
                    ldu     #bob_left2
                    rts

bob_clear           ldu #clear_hogs
                    rts

bob_right_hog       ldu     #hog__right
                    lda     #2
                    sta     bob_flag                    
                    rts

bob_right2_hog      ldu     #hog__right2
                    lda     #2
                    sta     bob_flag
                    rts

bob_left_hog        ldu     #hog__left
                    lda     #2
                    sta     bob_flag
                    rts

bob_left2_hog       ldu     #hog__left2
                    lda     #2
                    sta     bob_flag
                    rts

animate_count       inc     anim_counter
                    lda     anim_counter
                    cmpa    #10
                    bhi     ac_reset
                    rts
ac_reset            lda     #1
                    sta     anim_counter
                    rts

set3                lda     #3
                    sta     bob_flag
                    rts
                
bob_right  fcb %00001000,%10000000,%00000000,%00000010,%00100000,%00000000,%00000000,%10001000,%00000000,%00000000,%00100010,%00000000
           fcb %00100010,%00100000,%00000000,%00001000,%10001000,%00000000,%00000010,%00100010,%00000000,%00000000,%10001000,%10000000
           fcb %10001000,%10101000,%00000000,%00100010,%00101010,%00000000,%00001000,%10001010,%10000000,%00000010,%00100010,%10100000
           fcb %00100010,%10001000,%00000000,%00001000,%10100010,%00000000,%00000010,%00101000,%10000000,%00000000,%10001010,%00100000
           fcb %10001000,%10101010,%00000000,%00100010,%00101010,%10000000,%00001000,%10001010,%10100000,%00000010,%00100010,%10101000
           fcb %00100010,%00100010,%00000000,%00001000,%10001000,%10000000,%00000010,%00100010,%00100000,%00000000,%10001000,%10001000
           fcb %00101010,%10101000,%00000000,%00001010,%10101010,%00000000,%00000010,%10101010,%10000000,%00000000,%10101010,%10100000
           fcb %00001000,%00100000,%00000000,%00000010,%00001000,%00000000,%00000000,%10000010,%00000000,%00000000,%00100000,%10000000

bob_right2 fcb %00001000,%10000000,%00000000,%00000010,%00100000,%00000000,%00000000,%10001000,%00000000,%00000000,%00100010,%00000000
           fcb %00100010,%00100000,%00000000,%00001000,%10001000,%00000000,%00000010,%00100010,%00000000,%00000000,%10001000,%10000000
           fcb %10001000,%10101000,%00000000,%00100010,%00101010,%00000000,%00001000,%10001010,%10000000,%00000010,%00100010,%10100000
           fcb %00100010,%10001000,%00000000,%00001000,%10100010,%00000000,%00000010,%00101000,%10000000,%00000000,%10001010,%00100000
           fcb %10001000,%10101010,%00000000,%00100010,%00101010,%10000000,%00001000,%10001010,%10100000,%00000010,%00100010,%10101000
           fcb %00100010,%00100010,%00000000,%00001000,%10001000,%10000000,%00000010,%00100010,%00100000,%00000000,%10001000,%10001000
           fcb %00101010,%10101000,%00000000,%00001010,%10101010,%00000000,%00000010,%10101010,%10000000,%00000000,%10101010,%10100000
           fcb %00100000,%10000000,%00000000,%00001000,%00100000,%00000000,%00000010,%00001000,%00000000,%00000000,%10000010,%00000000

                    ; 3 First sprite            3 Second sprite                 3 Third sprite                   3 Fourth sprite

bob_left   fcb %00000000,%00000010,%00100000,%00000000,%00001000,%10000000,%00000000,%00100010,%00000000,%00000000,%10001000,%00000000
           fcb %00000000,%00001000,%10001000,%00000000,%00100010,%00100000,%00000000,%10001000,%10000000,%00000010,%00100010,%00000000
           fcb %00000000,%00101010,%00100010,%00000000,%10101000,%10001000,%00000010,%10100010,%00100000,%00001010,%10001000,%10000000
           fcb %00000000,%00100010,%10001000,%00000000,%10001010,%00100000,%00000010,%00101000,%10000000,%00001000,%10100010,%00000000
           fcb %00000000,%10101010,%00100010,%00000010,%10101000,%10001000,%00001010,%10100010,%00100000,%00101010,%10001000,%10000000
           fcb %00000000,%10001000,%10001000,%00000010,%00100010,%00100000,%00001000,%10001000,%10000000,%00100010,%00100010,%00000000
           fcb %00000000,%00101010,%10101000,%00000000,%10101010,%10100000,%00000010,%10101010,%10000000,%00001010,%10101010,%00000000
           fcb %00000000,%00001000,%00100000,%00000000,%00100000,%10000000,%00000000,%10000010,%00000000,%00000010,%00001000,%00000000

bob_left2  fcb %00000000,%00000010,%00100000,%00000000,%00001000,%10000000,%00000000,%00100010,%00000000,%00000000,%10001000,%00000000
           fcb %00000000,%00001000,%10001000,%00000000,%00100010,%00100000,%00000000,%10001000,%10000000,%00000010,%00100010,%00000000
           fcb %00000000,%00101010,%00100010,%00000000,%10101000,%10001000,%00000010,%10100010,%00100000,%00001010,%10001000,%10000000
           fcb %00000000,%00100010,%10001000,%00000000,%10001010,%00100000,%00000010,%00101000,%10000000,%00001000,%10100010,%00000000
           fcb %00000000,%10101010,%00100010,%00000010,%10101000,%10001000,%00001010,%10100010,%00100000,%00101010,%10001000,%10000000
           fcb %00000000,%10001000,%10001000,%00000010,%00100010,%00100000,%00001000,%10001000,%10000000,%00100010,%00100010,%00000000
           fcb %00000000,%00101010,%10101000,%00000000,%10101010,%10100000,%00000010,%10101010,%10000000,%00001010,%10101010,%00000000
           fcb %00000000,%00000010,%00001000,%00000000,%00001000,%00100000,%00000000,%00100000,%10000000,%00000000,%10000010,%00000000

;************************************************************************************************************************************************************
;***********************************************************Hog joystick code starting here******************************************************************
hog_joystick    jsr     hog_movement        
                jsr     hog_up_check
                jsr     hog_down_check
                jsr     hog_left_check
                jsr     hog_right_check
                rts

hog_up_check    ;ldb     hog_flag
                ;cmpb    #1
                ;beq     hog_up_flag_chk
hog_up_up       jsr     $a9de
                ldb     $015b
                cmpb    #$0f
                bls     hog_up
                rts

hog_down_check  ;ldb     hog_flag
                ;cmpb    #1
                ;beq     hog_down_flag_chk
hog_down_down   jsr     $a9de
                ldb     $015b
                cmpb    #$29
                lbhs     hog_down
return3         rts

;hog_up_flag_chk ldb     hog1_y
                ;cmpb    #2
                ;beq    return3
                ;bra     hog_up_up

;hog_down_flag_chk ldb   hog1_y
                ;cmpb    #136
                ;beq    return3
                ;bra     hog_down_down

hog_left_check  ldb     hog1_x
                cmpb    #1
                beq    return3
                jsr     $a9de
                ldb     $015a
                cmpb    #$0f
                lbls    hog_left
                rts

hog_right_check ldb     hog1_x
                cmpb    #120
                beq    return3
                jsr     $a9de
                ldb     $015a
                cmpb    #$29
                lbhs    hog_right
                rts
                
hog_up          jsr     hog_animate_count
                jsr     hog_jsclear
                ldx     hog_position
                leax    -$40,x
                stx     hog_position
                ldb     hog1_y
                subb    #2
                cmpb    #0
                beq     hog_rst_ypos1                  
                stb     hog1_y
                cmpb    #2                          ;is hog1_y 2
                beq     hack_hog_y_top              ;if so branch to set hog4_y to 9
                cmpb    #136
                beq     hack_hog_y_bottom           ;This is a mess, may need to make another section for this
                bra     hog_chky4
hog_ypos_rtn1   jsr     hog_movement
                bra     hog_chky4
hog_rst_ypos1   ldb     #144
                stb     hog1_y
                bra     hog_ypos_rtn1
hog_chky4       ldb     hog4_y
                subb    #2
                cmpb    #1
                blo     hog_rst_ypos4               ;this may do it      
                stb     hog4_y
hog_ypos_rtn4   jsr     hog_movement
                rts
hog_rst_ypos4   ldb     #145
                stb     hog4_y
                bra     hog_ypos_rtn4

hack_hog_y_top  ldb     #9
                stb     hog4_y
                bra     hog_ypos_rtn4               ;this did branch to chky4

hog_down        jsr     hog_animate_count
                jsr     hog_jsclear
                ldx     hog_position
                leax    $40,x
                stx     hog_position
                ldb     hog1_y
                addb    #2
                cmpb    #146
                beq     hog_rst_ypos                    
                stb     hog1_y
                cmpb    #2                          ;is hog1_y 2
                beq     hack_hog_y_top              ;if so branch to set hog4_y to 9
                cmpb    #136                        ;is hog1_y 136
                beq    hack_hog_y_bottom            ;if so branch to set hog4_y to 143
                bra     hog_chky5
hog_ypos_rtn    jsr     hog_movement
                bra     hog_chky5
hog_rst_ypos    ldb     #2
                stb     hog1_y
                bra     hog_ypos_rtn
hog_chky5       ldb     hog4_y
                addb    #2
                cmpb    #145
                bhs     hog_rst_ypos5                              
                stb     hog4_y
hog_ypos_rtn5   jsr     hog_movement
                rts
hog_rst_ypos5   ldb     #1
                stb     hog4_y
                bra     hog_ypos_rtn5

hack_hog_y_bottom  ldb  #143
                stb     hog4_y
                bra     hog_ypos_rtn5               ;this did branch to chky5

hog_left        jsr     hog_animate_count
                jsr     hog_jsclear
                ldb     hog_animation
                cmpb    #4           ; **************************************************************************
                blo     hog_onon           ; jmp to "on" if animation is lower than 5, this moves in the byte without increasing the byte address    
                ldx     hog_position
                leax    -1,x
                stx     hog_position
                dec     hog_xpos
hog_onon        inc     hog_animation
                ldb     #2
                stb     hog_direction
                jsr     hog_movement
                rts

hog_right       jsr     hog_animate_count
                jsr     hog_jsclear
                ldb     hog_animation
                cmpb    #4           ; **************************************************************************
                blo     hog_on            ; jmp to "on" if animation is lower than 5, this moves in the byte without increasing the byte address    
                ldx     hog_position
                leax    1,x
                stx     hog_position
                inc     hog_xpos
hog_on          inc     hog_animation
                ldb     #1
                stb     hog_direction
                jsr     hog_movement
                rts

hog_jsclear     ldb     #8
                ldx     hog_position
                lda     #%00000000
hog_clr         cmpx    #$9ff
                lbls    hog_complete_below_c
                cmpx    #$1c00
                lbhs    hog_complete_above_c
                sta     ,x+
                sta     ,x+
                sta     ,x
                leax    30,x
                decb
                bne     hog_clr
                rts

hog_movement    lda     hog_animation
                cmpa    #4                     
                lbhi    hog_reset
                lda     hog_animation
                cmpa    #1
                beq     hog_anim
                cmpa    #2
                beq     hog_anim2
                cmpa    #3
                beq     hog_anim3
                cmpa    #4
                lbeq    hog_anim4

hog_anim        ;lda     hog_flag
                ;cmpa    #1
                ;beq    return4              ;07_03
                ldb     #8
                ldx     hog_position
                jsr     hog_direction_chk  
hog_jsdraw      cmpx    #$9ff                   ; if animation is 1 it will continue here
                lbls    hog_complete_below
                cmpx    #$1c00
                lbhs    hog_complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     hog_jsdraw
                lda     hog_flag
                cmpa    #2
                lbeq    hog_set3
return4         rts

hog_anim2       ;lda     hog_flag
                ;cmpa    #1
                ;beq    return4              ;07_03
                ldb     #8
                ldx     hog_position
                jsr     hog_direction_chk   
                leau    3,u
hog_jsdraw2     cmpx    #$9ff
                lbls    hog_complete_below
                cmpx    #$1c00
                lbhs    hog_complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     hog_jsdraw2
                lda     hog_flag
                cmpa    #2
                lbeq    hog_set3
                rts

hog_anim3       ;lda     hog_flag
                ;cmpa    #1
                ;beq    return4              ;07_03
                ldb     #8
                ldx     hog_position   
                jsr     hog_direction_chk
                leau    6,u
hog_jsdraw3     cmpx    #$9ff
                lbls    hog_complete_below
                cmpx    #$1c00
                bhs     hog_complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     hog_jsdraw3
                lda     hog_flag
                cmpa    #2
                lbeq    hog_set3
                rts

hog_anim4       ;lda     hog_flag
                ;cmpa    #1
                ;beq    return4              ;07_03
                ldb     #8
                ldx     hog_position   
                jsr     hog_direction_chk
                leau    9,u
hog_jsdraw4     cmpx    #$9ff
                bls     hog_complete_below
                cmpx    #$1c00
                bhs     hog_complete_above
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x+
                lda     ,u+
                sta     ,x
                leax    30,x
                leau    9,u
                decb
                bne     hog_jsdraw4
                lda     hog_flag
                cmpa    #2
                lbeq    hog_set3
                rts

hog_reset       lda     #1
                sta     hog_animation
                lbra    hog_movement

hog_complete_above  leax    -$1200,x
                    ldy     hog_position
                    leay    -$1200,y
                    sty     hog_position
                    lbra    hog_jsdraw

hog_complete_below  leax    $1200,x
                    ldy     hog_position
                    leay    $1200,y
                    sty     hog_position
                    lbra    hog_jsdraw

hog_complete_above_c    leax    -$1200,x
                    lbra     hog_clr

hog_complete_below_c    leax    $1200,x
                    lbra     hog_clr

hog_direction_chk   lda     hog_direction
                    cmpa    #1
                    bne     hog_direction_chk2
                    lda     hog_anim_counter
                    cmpa    #5
                    bhi     hog_right2
                    lda     hog_flag
                    cmpa    #1
                    beq     hog_clear
                    cmpa    #3
                    beq     hog_right_bob               
                    bhi     tenticle                    ;added 04_05_24
                    ldu     #hog__right                
                    rts
hog_right2          lda     hog_flag
                    cmpa    #1
                    beq     hog_clear
                    cmpa    #3
                    beq     hog_right2_bob
                    bhi     tenticle                    ;added 04_05_24
                    ldu     #hog__right2
                    rts

tenticle            ldu     #tenticles
                    rts

hog_direction_chk2  lda     hog_anim_counter
                    cmpa    #5
                    bhi     hog_left2
                    lda     hog_flag
                    cmpa    #1
                    beq     hog_clear
                    cmpa    #3
                    beq     hog_left_bob
                    ldu     #hog__left
                    rts
hog_left2           lda     hog_flag
                    cmpa    #1
                    beq     hog_clear
                    cmpa    #3
                    beq     hog_left2_bob
                    ldu     #hog__left2
                    rts

hog_clear           ldu     #clear_hogs
                    rts

hog_right_bob       ldu     #red_right
                    lda     #2
                    sta     hog_flag                    
                    rts

hog_right2_bob      ldu     #red_right2
                    lda     #2
                    sta     hog_flag
                    rts

hog_left_bob        ldu     #red_left
                    lda     #2
                    sta     hog_flag
                    rts

hog_left2_bob       ldu     #red_left2
                    lda     #2
                    sta     hog_flag
                    rts

hog_animate_count   inc     hog_anim_counter
                    lda     hog_anim_counter
                    cmpa    #10
                    bhi     hog_ac_reset
                    rts
hog_ac_reset        lda     #1
                    sta     hog_anim_counter
                    rts

hog_set3            lda     #3
                    sta     hog_flag
                    rts
                
hog__right fcb %00000100,%01000000,%00000000,%00000001,%00010000,%00000000,%00000000,%01000100,%00000000,%00000000,%00010001,%00000000
           fcb %00010001,%00010000,%00000000,%00000100,%01000100,%00000000,%00000001,%00010001,%00000000,%00000000,%01000100,%01000000
           fcb %01000100,%01010100,%00000000,%00010001,%00010101,%00000000,%00000100,%01000101,%01000000,%00000001,%00010001,%01010000
           fcb %00010001,%01000100,%00000000,%00000100,%01010001,%00000000,%00000001,%00010100,%01000000,%00000000,%01000101,%00010000
           fcb %01000100,%01010101,%00000000,%00010001,%00010101,%01000000,%00000100,%01000101,%01010000,%00000001,%00010001,%01010100
           fcb %00010001,%00010001,%00000000,%00000100,%01000100,%01000000,%00000001,%00010001,%00010000,%00000000,%01000100,%01000100
           fcb %00010101,%01010100,%00000000,%00000101,%01010101,%00000000,%00000001,%01010101,%01000000,%00000000,%01010101,%01010000
           fcb %00000100,%00010000,%00000000,%00000001,%00000100,%00000000,%00000000,%01000001,%00000000,%00000000,%00010000,%01000000

hog__right2 fcb %00000100,%01000000,%00000000,%00000001,%00010000,%00000000,%00000000,%01000100,%00000000,%00000000,%00010001,%00000000
           fcb %00010001,%00010000,%00000000,%00000100,%01000100,%00000000,%00000001,%00010001,%00000000,%00000000,%01000100,%01000000
           fcb %01000100,%01010100,%00000000,%00010001,%00010101,%00000000,%00000100,%01000101,%01000000,%00000001,%00010001,%01010000
           fcb %00010001,%01000100,%00000000,%00000100,%01010001,%00000000,%00000001,%00010100,%01000000,%00000000,%01000101,%00010000
           fcb %01000100,%01010101,%00000000,%00010001,%00010101,%01000000,%00000100,%01000101,%01010000,%00000001,%00010001,%01010100
           fcb %00010001,%00010001,%00000000,%00000100,%01000100,%01000000,%00000001,%00010001,%00010000,%00000000,%01000100,%01000100
           fcb %00010101,%01010100,%00000000,%00000101,%01010101,%00000000,%00000001,%01010101,%01000000,%00000000,%01010101,%01010000
           fcb %00010000,%01000000,%00000000,%00000100,%00010000,%00000000,%00000001,%00000100,%00000000,%00000000,%01000001,%00000000

                    ; 3 First sprite            3 Second sprite                 3 Third sprite                   3 Fourth sprite

hog__left  fcb %00000000,%00000001,%00010000,%00000000,%00000100,%01000000,%00000000,%00010001,%00000000,%00000000,%01000100,%00000000
           fcb %00000000,%00000100,%01000100,%00000000,%00010001,%00010000,%00000000,%01000100,%01000000,%00000001,%00010001,%00000000
           fcb %00000000,%00010101,%00010001,%00000000,%01010100,%01000100,%00000001,%01010001,%00010000,%00000101,%01000100,%01000000
           fcb %00000000,%00010001,%01000100,%00000000,%01000101,%00010000,%00000001,%00010100,%01000000,%00000100,%01010001,%00000000
           fcb %00000000,%01010101,%00010001,%00000001,%01010100,%01000100,%00000101,%01010001,%00010000,%00010101,%01000100,%01000000
           fcb %00000000,%01000100,%01000100,%00000001,%00010001,%00010000,%00000100,%01000100,%01000000,%00010001,%00010001,%00000000
           fcb %00000000,%00010101,%01010100,%00000000,%01010101,%01010000,%00000001,%01010101,%01000000,%00000101,%01010101,%00000000
           fcb %00000000,%00000100,%00010000,%00000000,%00010000,%01000000,%00000000,%01000001,%00000000,%00000001,%00000100,%00000000

hog__left2 fcb %00000000,%00000001,%00010000,%00000000,%00000100,%01000000,%00000000,%00010001,%00000000,%00000000,%01000100,%00000000
           fcb %00000000,%00000100,%01000100,%00000000,%00010001,%00010000,%00000000,%01000100,%01000000,%00000001,%00010001,%00000000
           fcb %00000000,%00010101,%00010001,%00000000,%01010100,%01000100,%00000001,%01010001,%00010000,%00000101,%01000100,%01000000
           fcb %00000000,%00010001,%01000100,%00000000,%01000101,%00010000,%00000001,%00010100,%01000000,%00000100,%01010001,%00000000
           fcb %00000000,%01010101,%00010001,%00000001,%01010100,%01000100,%00000101,%01010001,%00010000,%00010101,%01000100,%01000000
           fcb %00000000,%01000100,%01000100,%00000001,%00010001,%00010000,%00000100,%01000100,%01000000,%00010001,%00010001,%00000000
           fcb %00000000,%00010101,%01010100,%00000000,%01010101,%01010000,%00000001,%01010101,%01000000,%00000101,%01010101,%00000000
           fcb %00000000,%00000001,%00000100,%00000000,%00000100,%00010000,%00000000,%00010000,%01000000,%00000000,%01000001,%00000000

;*******************This red hedgehog data is used just to flash the sprite in a 2 player game. It's a little wasteful****************

red_right  fcb %00001100,%11000000,%00000000,%00000011,%00110000,%00000000,%00000000,%11001100,%00000000,%00000000,%00110011,%00000000
           fcb %00110011,%00110000,%00000000,%00001100,%11001100,%00000000,%00000011,%00110011,%00000000,%00000000,%11001100,%11000000
           fcb %11001100,%11111100,%00000000,%00110011,%00111111,%00000000,%00001100,%11001111,%11000000,%00000011,%00110011,%11110000
           fcb %00110011,%11001100,%00000000,%00001100,%11110011,%00000000,%00000011,%00111100,%11000000,%00000000,%11001111,%00110000
           fcb %11001100,%11111111,%00000000,%00110011,%00111111,%11000000,%00001100,%11001111,%11110000,%00000011,%00110011,%11111100
           fcb %00110011,%00110011,%00000000,%00001100,%11001100,%11000000,%00000011,%00110011,%00110000,%00000000,%11001100,%11001100
           fcb %00111111,%11111100,%00000000,%00001111,%11111111,%00000000,%00000011,%11111111,%11000000,%00000000,%11111111,%11110000
           fcb %00001100,%00110000,%00000000,%00000011,%00001100,%00000000,%00000000,%11000011,%00000000,%00000000,%00110000,%11000000

red_right2 fcb %00001100,%11000000,%00000000,%00000011,%00110000,%00000000,%00000000,%11001100,%00000000,%00000000,%00110011,%00000000
           fcb %00110011,%00110000,%00000000,%00001100,%11001100,%00000000,%00000011,%00110011,%00000000,%00000000,%11001100,%11000000
           fcb %11001100,%11111100,%00000000,%00110011,%00111111,%00000000,%00001100,%11001111,%11000000,%00000011,%00110011,%11110000
           fcb %00110011,%11001100,%00000000,%00001100,%11110011,%00000000,%00000011,%00111100,%11000000,%00000000,%11001111,%00110000
           fcb %11001100,%11111111,%00000000,%00110011,%00111111,%11000000,%00001100,%11001111,%11110000,%00000011,%00110011,%11111100
           fcb %00110011,%00110011,%00000000,%00001100,%11001100,%11000000,%00000011,%00110011,%00110000,%00000000,%11001100,%11001100
           fcb %00111111,%11111100,%00000000,%00001111,%11111111,%00000000,%00000011,%11111111,%11000000,%00000000,%11111111,%11110000
           fcb %00110000,%11000000,%00000000,%00001100,%00110000,%00000000,%00000011,%00001100,%00000000,%00000000,%11000011,%00000000

                    ; 3 First sprite            3 Second sprite                 3 Third sprite                   3 Fourth sprite

red_left   fcb %00000000,%00000011,%00110000,%00000000,%00001100,%11000000,%00000000,%00110011,%00000000,%00000000,%11001100,%00000000
           fcb %00000000,%00001100,%11001100,%00000000,%00110011,%00110000,%00000000,%11001100,%11000000,%00000011,%00110011,%00000000
           fcb %00000000,%00111111,%00110011,%00000000,%11111100,%11001100,%00000011,%11110011,%00110000,%00001111,%11001100,%11000000
           fcb %00000000,%00110011,%11001100,%00000000,%11001111,%00110000,%00000011,%00111100,%11000000,%00001100,%11110011,%00000000
           fcb %00000000,%11111111,%00110011,%00000011,%11111100,%11001100,%00001111,%11110011,%00110000,%00111111,%11001100,%11000000
           fcb %00000000,%11001100,%11001100,%00000011,%00110011,%00110000,%00001100,%11001100,%11000000,%00110011,%00110011,%00000000
           fcb %00000000,%00111111,%11111100,%00000000,%11111111,%11110000,%00000011,%11111111,%11000000,%00001111,%11111111,%00000000
           fcb %00000000,%00001100,%00110000,%00000000,%00110000,%11000000,%00000000,%11000011,%00000000,%00000011,%00001100,%00000000

red_left2  fcb %00000000,%00000011,%00110000,%00000000,%00001100,%11000000,%00000000,%00110011,%00000000,%00000000,%11001100,%00000000
           fcb %00000000,%00001100,%11001100,%00000000,%00110011,%00110000,%00000000,%11001100,%11000000,%00000011,%00110011,%00000000
           fcb %00000000,%00111111,%00110011,%00000000,%11111100,%11001100,%00000011,%11110011,%00110000,%00001111,%11001100,%11000000
           fcb %00000000,%00110011,%11001100,%00000000,%11001111,%00110000,%00000011,%00111100,%11000000,%00001100,%11110011,%00000000
           fcb %00000000,%11111111,%00110011,%00000011,%11111100,%11001100,%00001111,%11110011,%00110000,%00111111,%11001100,%11000000
           fcb %00000000,%11001100,%11001100,%00000011,%00110011,%00110000,%00001100,%11001100,%11000000,%00110011,%00110011,%00000000
           fcb %00000000,%00111111,%11111100,%00000000,%11111111,%11110000,%00000011,%11111111,%11000000,%00001111,%11111111,%00000000
           fcb %00000000,%00000011,%00001100,%00000000,%00001100,%00110000,%00000000,%00110000,%11000000,%00000000,%11000011,%00000000



tenticles  fcb %10001000,%10001000,%00000000,%00100010,%00100010,%00000000,%00001000,%10001000,%10000000,%00000010,%00100010,%00100000
           fcb %00100010,%00100010,%00000000,%00001000,%10001000,%10000000,%00100000,%10000010,%00100000,%00001000,%00100000,%10001000
           fcb %10000000,%10001000,%10000000,%00100000,%00100010,%00100000,%00001000,%00100010,%00001000,%00000010,%00001000,%10000010
           fcb %00100010,%00000010,%00100000,%00001000,%10000000,%10001000,%00100000,%00100000,%10001000,%00001000,%00001000,%00100010
           fcb %00100000,%10000010,%00001000,%00001000,%00100000,%10000010,%10000000,%10000010,%00100000,%00100000,%00100000,%10001000
           fcb %10000000,%10000000,%10001000,%00100000,%00100000,%00000010,%00100010,%00001000,%00100000,%00001000,%10000010,%00001000
           fcb %00100010,%00000010,%00100000,%00001000,%10000000,%10001000,%00100000,%10000010,%00001000,%00001000,%00100000,%10000010
           fcb %00000000,%10001000,%00001000,%00000000,%00100010,%00000010,%00000000,%10001000,%00100000,%00000000,%00100010,%00001000 

clear_hogs fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
           fcb %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000

;*****************************************************************************************************************************************
;********************************************************* Game over animation ***********************************************************

end_transport   jsr     winclr      ;clear screen
trn_anim        jsr     movement    ;draw Bob                               *****************BOB TURNING ANIMATION*********
                ldx     #$ffff      ;set up counter
reduce          leax    -1,x
                bne     reduce      ;reduce until 0
                ldx     #$5000
reduce2         leax    -1,x
                bne     reduce2
                inc     $ff         ;increment counter
                lda     $ff
                cmpa    #3          ;changed from 5
                beq     transport   ;once above ran through 3 times go to transport anim    *******BEQ TO AN RTS******
                lda     direction
                cmpa    #1          ;check direction and change it
                beq     add_dir
                deca
                sta     direction                
                bra     trn_anim    ;branch back to above               

add_dir         inca                ;section changes direction from 1 to 2
                sta     direction
                bra     trn_anim                                                        ;********BOB TURNING ANIM ENDS HERE*******

transport       ldx     #$800       ; set counter to # above threshold     ***timer for transporter sound duration and animation
                stx     $fe         ;store it
                ldb     #3
                stb     bob_flag    ;set bob flag to flashing Bob from 2 player game
trans           jsr     movement
                ldb     bob_flag
                cmpb    #3
                beq     flag_0
                ldb     #3
                stb     bob_flag    ;the above changes bob_flag from 0 to 3 and vice versa
                ldx     $fe
                leax    -1,x
                stx     $fe         ;decrease and store countdown timer
                cmpx    #$500       ;counter threshold
                beq     bob_gone    ;go here when x gets to $500
                bra     trans_sound

flag_0          ldb #0              ;routine to change bob_flag from 3 to 0
                stb bob_flag
                bra trans

trans_sound     lda #$3f                ;set up sound stuff (DAC)
                sta $ff23
                ldb $9f                 ;store 0 to b
                inc $9f                 ;and increment
store_          orb #%10
                stb $ff20
                incb                    ;run through tone stuff
                bne store_
                bra trans

bob_gone        lda #1                  ;set bob up for his collect fly sound  ***THIS WHOLE SECTION IS A BIT SHIT***
                sta bob_beep_flag
                jsr bob_sound           ;play the sound X4
                jsr bob_sound
                jsr bob_sound
                jsr bob_sound
                jsr jsclear             ;Bob vanishes
                ldx $ffff
wait            leax    -1,x
                bne wait
                lda game_type           ;modified 01_05_24
                cmpa #3
                lbeq gogoagain
                lbra transport_code

;******************************************************END GAME ANIMATIONS*******************************************************

bug_explode     jsr winclr

                ldx #$100
                stx $fe
                lda #4
                sta red1
                lda #8
                sta red2
                lda #12
                sta red3

                jsr movement
                ldx #$1000
rback           leax    -1,x
                pshs    x
                jsr xtime_2plr
                puls    x
                bne rback

bug_sound       lda #$3f
                sta $ff23
                ldx #$df
lo              ldb #$9f
st              orb #%10
                stb $ff20
                incb
                bne st
                leax    -1,x
                bne lo

                jsr initial_clear

trn_anim2       jsr     movement    ;draw Bob                                   *****************BOB TURNING ANIMATION*********
                ldx     #$ffff      ;set up counter
reduce3         leax    -1,x
                bne     reduce3     ;reduce until 0
                ldx     #$ffff
reduce4         leax    -1,x
                bne     reduce4
                inc     $ff         ;increment counter
                lda     $ff
                cmpa    #3          ;changed from 5
                beq     bob_godown                      ;added 24/03/24 to try to resolve infinite run bug when bob's half up half down                
                ;beq     bob_run     ;once above ran through 3 times go to transport anim           *******BEQ TO AN RTS******
                lda     direction
                cmpa    #1          ;check direction and change it
                beq     add_dir2
                deca
                sta     direction                
                bra     trn_anim2   ;branch back to above

add_dir2        inca                ;section changes direction from 1 to 2
                sta     direction
                bra     trn_anim2                                                                   ;********BOB TURNING ANIM ENDS HERE*******

bob_godown      ldb bob1_y                              ;added 24/03/24 to try to resolve infinite run bug when bob's half up half down 
                cmpb bob4_y
                blo bob_run
                lda direction
                cmpa #1
                beq upgo
                lda #16
                pshs a
getinplace      ldx #$700
xdown           leax -1,x
                bne xdown
                jsr down
                puls a
                deca
                pshs a
                bne getinplace
                bra bob_run
upgo            lda #16
                pshs a
getinplace2     ldx #$700
xdown2          leax -1,x
                bne xdown2
                jsr up
                puls a
                deca
                pshs a
                bne getinplace2
                bra bob_run

bob_run         ldy #0
                lda direction
                cmpa    #2
                beq run_left

run_right       leay 1,y
                jsr right
                ldx #$700
slowr           leax -1,x
                bne slowr
                cmpy #128
                lbeq explode_code
                bra run_right

run_left        leay 1,y
                jsr left
                ldx #$700
slowl           leax -1,x
                bne slowl
                cmpy #128
                lbeq explode_code
                bra run_left

easteregg_code      jsr clrscn                  ;added 02_05_24
                    ldx #$420
                    ldu #easteregg_text1
                    jsr text_code
                    jsr slight_pause
                    ldx #$460
                    ldu #easteregg_text5
                    jsr text_code
                    jsr slight_pause
                    ldx #$4a0
                    ldu #easteregg_text2
                    jsr text_code
                    jsr slight_pause
                    ldx #$4e0
                    ldu #easteregg_text5
                    jsr text_code
                    jsr slight_pause
                    ldx #$520
                    ldu #easteregg_text3
                    jsr text_code
                    jsr slight_pause
                    ldx #$560
                    ldu #easteregg_text5
                    jsr text_code
                    jsr slight_pause
                    ldx #$5a0
                    ldu #easteregg_text4
                    jsr text_code
                    jsr slight_pause
                    jsr reset_game
                    lda #255
                    sta $ff
trn_anim3       jsr     movement    ;draw Bob                                   *****************BOB TURNING ANIMATION*********
                ldx     #$ffff      ;set up counter
reduce33         leax    -1,x
                bne     reduce33     ;reduce until 0
                ldx     #$ffff
reduce34         leax    -1,x
                bne     reduce34
                inc     $ff         ;increment counter
                lda     $ff
                cmpa    #3          ;changed from 5
                beq     bob_tenticles                      ;added 24/03/24 to try to resolve infinite run bug when bob's half up half down                
                ;beq     bob_run     ;once above ran through 3 times go to transport anim           *******BEQ TO AN RTS******
                lda     direction
                cmpa    #1          ;check direction and change it
                beq     add_dir32
                deca
                sta     direction                
                bra     trn_anim3   ;branch back to above

add_dir32       inca                ;section changes direction from 1 to 2
                sta     direction
                bra     trn_anim3                                                                   ;********BOB TURNING ANIM ENDS HERE*******

bob_tenticles  lda #190
               ldb     #4
               stb     hog_flag
egg_end        pshs a 
tent_run       jsr right
               jsr meld
               ldx #$1400
waiting        leax -1,x
               bne waiting
               puls a
               deca               
               bne egg_end

easteregg_end_message   jsr sg4_setup                  ;added 04_05_24
                        jsr clrscn
                        ldx #$420
                        ldu #eggend_text
                        jsr text_code
                        pshs x
                        ldx bob_rollover
                        leax 50,x
                        stx bob_rollover
                        stx buffer
                        puls x
                        jsr hex_to_ascii
                        jsr display_score
                        ldx buffer
                        cmpx todays_highest            ;added this evening of 04_05_24 cause of bug where 50 bonus points not saved to todays highest
                        bls this_thing_here
                        stx todays_highest
this_thing_here         jsr keypress
                       
                        bra prog_start

                        

meld            leax -$20,x                          ;03_05_24****draw tenticles to work with the bob animation and stick the code to place them here****
                stx hog_position
                lda animation                   ;assign a bob4_flag that will indicate loading tenticles to U before bob left or right draw then you can
                sta hog_animation               ;use bob position, direction, anim counter etc to select the correct tenticle sprite and draw it
                jsr hog_right
                deca
                rts


slight_pause        ldx #$ffff
back1               leax -1,x
                    bne back1
                    ldx #$ffff
back2               leax -1,x
                    bne back2
                    rts

;***************************************SG4 SCREEN SETUP AND TEXT CODE**********************************************

sg4_setup       sta     $ffc6                   ;sets up screen addressed from $400 to $600
		        sta     $ffc8+1
                sta     $ffca
                sta     $ffcc
                sta     $ffce
                sta     $ffd0
                sta     $ffd2

                lda     #%00000000              ; select mode sg4
		        sta     $ff22                   ; and store it to the VDG
                sta     $ffc0
		        sta     $ffc2                   ; set V1
		        sta     $ffc4                   ; set V2
                
                rts

prog_start      ldx #$400
                lda #%00100000
clear0          sta ,x+
                cmpx #$600
                blo clear0

menu_code       jsr clrscn
                ldx #$420
                ldu #menu
                jsr text_code
                ldx todays_highest
                cmpx #0
                bhi todays_highests
                jsr menukey

todays_highests ldu #menu_score_text
                ldx #$580
                jsr text_code
                pshs x
                ldx todays_highest
                stx buffer
                puls x
                jsr hex_to_ascii
                jsr display_score               
                jsr menukey

inst1_code      jsr clrscn      
                ldx #$400
                ldu #inst1
                jsr text_code
                jsr keypress

inst2_code      ldx #$400
                ldu #inst2
                jsr text_code
                jsr keypress

inst3_code      ldx #$400
                ldu #inst3
                jsr text_code
                jsr keypress

inst4_code      ldx #$400
                ldu #inst4
                jsr text_code
                jsr keypress
                bra menu_code

story1_code     jsr clrscn
                ldx #$400
                ldu #story1
                jsr text_code
                jsr keypress

story2_code     ldx #$400
                ldu #story2
                jsr text_code
                jsr keypress

story3_code     ldx #$400
                ldu #story3
                jsr text_code
                jsr keypress

story4_code     ldx #$400
                ldu #story4
                jsr text_code
                jsr keypress
                lbra menu_code

thanks1_code    jsr clrscn
                ldx #$400
                ldu #thanks1
                jsr text_code
                jsr keypress
                lbra menu_code

practice_code   clr bob_score
                clr bob_rollover
practice_codel  jsr sg4_setup
                jsr clrscn              ;01_05_24
                ldx #$480
                ldu #practice_text
                jsr text_code
                jsr keypress
                jsr reset_game
                lda #3                  ;set transporter speed
                sta game_type
                lda player1_level
                cmpa #5                 ;5 gives wide doors while 8 gives narrow ones
                beq set_8
                lda #5
                sta player1_level 
level_set       lbra practice_mode          ;branch to next clear level in practice mode
set_8           lda #8
                sta player1_level
                bra level_set

explode_code    lda game_type               ;added 01_05_24
                cmpa #3
                beq gogo
                ldx bob_rollover
                cmpx todays_highest
                bls gogo
                stx todays_highest
gogo            stx buffer
                jsr sg4_setup
                jsr clrscn
                ldx #$480
                ldu #bug_explodes
                jsr text_code
                lda game_type                       ;added 01_05_24
                cmpa #3
                beq practice_message
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$540
                ldu #try_again
                jsr text_code
                lda player1_level                   ;added this check for easteregg cue 02_05_24
                cmpa #10
                lbhi keypress_easteregg 
                lbra keypress2

                
transport_code  ldx bob_rollover
                cmpx todays_highest
                bls gogoagain
                stx todays_highest
gogoagain       stx buffer
                jsr sg4_setup
                jsr clrscn
                ldx #$480
                ldu #transporter_hit
                jsr text_code
                lda game_type                       ;added 01_05_24
                cmpa #3
                beq practice_message
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$540
                ldu #try_again
                jsr text_code 
                lbra keypress2

practice_message  ldx #$500                         ;added 01_05_24
                ldu #practice_mess
                jsr text_code
                pshs x                              ;modified 04_05_24
                ldx bob_rollover
                stx buffer
                puls x
                jsr hex_to_ascii
                jsr display_score
                jsr keypress
                lbeq menu_code

colour_line_code ldx bob_rollover
                stx buffer
                jsr sg4_setup                      ;screen SG4 setup
                jsr clrscn                          ;clear screen routine
                ldx #$400                           ;pointer to top left
                ldu #bonus_bug_line                 ;load first text segment
                jsr text_code                       ;print segment to screen
                pshs x                              ;****OOOOhhhh what a waste of cycles and bytes the next 12 lines are, (don't care :))
                ldx bob_rollover
                leax -16,x
                stx buffer
                puls x
                jsr hex_to_ascii                    ;convert whatever's stored in score to ascii
                jsr display_score                   ;display ascii conversion on screen
                pshs x
                ldx bob_rollover
                leax 16,x
                stx buffer
                puls x
                ldb blue_total_line                 ;put number of blue bugs lines in b
                jsr hex2ascii                       ;go to 8bit ascii routine
                ldx #$485                           ;set pointer to where text is to be displayed
                jsr display_score                   ;print ascii to screen (blue bug line no.)
                ldu #line_data_blue                 ;load blue line text segment
                jsr text_code                       ;print line_data_blue text to screen
                lda #4                              ;store 4 in a (points a comple blue line gets)
                ldb blue_total_line                 ;store number of lines got in b
                mul                                 ;a by b answer in b
                pshs b                              ;you need to keep the value of b to display later
                clra
                addd bob_rollover                   ;add bonus to score
                std bob_rollover                    ;b has changed as the bonus was added to and all
                std buffer
                puls b                              ;so pull it back from the stack
                jsr hex2ascii
                jsr display_score

yellowline      ldx bob_rollover
                stx buffer
                ldb yellow_total_line               ;put number of blue bugs lines in b
                jsr hex2ascii                       ;go to 8bit ascii routine
                ldx #$4a5                           ;set pointer to where text is to be displayed
                jsr display_score                   ;print ascii to screen (blue bug line no.)
                ldu #line_data_yell                 ;load blue line text segment
                jsr text_code                       ;print line_data_blue text to screen
                lda #8                              ;store 4 in a (points a comple blue line gets)
                ldb yellow_total_line               ;store number of lines got in b
                mul                                 ;a by b answer in b
                pshs b
                clra
                addd bob_rollover                   ;add bonus to score
                std bob_rollover
                std buffer
                puls b
                jsr hex2ascii
                jsr display_score

redline         ldx bob_rollover
                stx buffer
                ldb red_total_line                 ;put number of blue bugs lines in b
                jsr hex2ascii                       ;go to 8bit ascii routine
                ldx #$4c5                           ;set pointer to where text is to be displayed
                jsr display_score                   ;print ascii to screen (blue bug line no.)
                ldu #line_data_red                 ;load blue line text segment
                jsr text_code                       ;print line_data_blue text to screen
                lda #12                              ;store 4 in a (points a comple blue line gets)
                ldb red_total_line                 ;store number of lines got in b
                mul                                 ;a by b answer in b
                pshs b
                clra
                addd bob_rollover                   ;add bonus to score
                std bob_rollover
                std buffer
                puls b
                jsr hex2ascii
                jsr display_score

                 
                ldx #$500                           ;display end portion
                ldu #line_data_16
                jsr text_code
                jsr hex_to_ascii
                jsr display_score                   ;display updated score
                ldx #$560
                ldu #line_data_16_2
                jsr text_code
                ldb player1_level                   ;load next level number
                jsr hex2ascii
                jsr display_score                   ;and display
                
                lbra keypress3                      ;for now **********

blue_block_code ldx bob_rollover
                stx buffer
                jsr sg4_setup
                jsr clrscn
                ldx #$400
                ldu #bonus_all_fill
                jsr text_code
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$480
                ldu #blue_after
                jsr text_code
                pshs x
                ldx bob_rollover
                leax 32,x
                stx bob_rollover
                stx buffer
                puls x
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$5a0
                ldu #level_txt
                jsr text_code
                ldb player1_level
                jsr hex2ascii
                ldx #$5f3
                jsr display_score
                lbra keypress3
yellow_block_code ldx bob_rollover
                stx buffer
                jsr sg4_setup
                jsr clrscn
                ldx #$400
                ldu #bonus_all_fill
                jsr text_code
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$480
                ldu #yellow_after
                jsr text_code
                pshs x
                ldx bob_rollover
                leax 64,x
                stx bob_rollover
                stx buffer
                puls x
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$5a0
                ldu #level_txt
                jsr text_code
                ldb player1_level
                jsr hex2ascii
                ldx #$5f3
                jsr display_score
                lbra keypress3
red_block_code  ldx bob_rollover
                stx buffer
                jsr sg4_setup
                jsr clrscn
                ldx #$400
                ldu #bonus_all_fill
                jsr text_code
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$480
                ldu #red_after
                jsr text_code
                pshs x
                ldx bob_rollover
                leax 96,x
                stx bob_rollover
                stx buffer
                puls x
                jsr hex_to_ascii                    ;Here you need to jump to the code that converts the HEX score to decimal ASCII and display it at $516
                jsr display_score
                ldx #$5a0
                ldu #level_txt
                jsr text_code
                ldb player1_level
                jsr hex2ascii                       
                ldx #$5f3
                jsr display_score
                lbra keypress3

display_score   lda $94                             ;then ldu with more text asking if you'd like to play again and display it at $540.
                cmpa #$30
                beq thousands
                lda $93                             
                sta ,x+
                sta ,x+
                lda $92
                sta ,x+
                lda $91
                sta ,x+
                lda $90
                sta ,x+
                rts
thousands       lda $93                            
                cmpa #$30
                beq hundrids
                sta ,x+
                lda $92
                sta ,x+
                lda $91
                sta ,x+
                lda $90
                sta ,x+
                rts
hundrids        lda $92
                cmpa #$30
                beq tens
                sta ,x+
                lda $91
                sta ,x+
                lda $90
                sta ,x+
                rts
tens            lda $91
                cmpa #$30
                beq units
                sta ,x+
                lda $90
                sta ,x+
                rts
units           lda $90
                sta ,x+
                rts

hex_to_ascii    pshs x                              ;This section takes the 16bit score data in hex and converts it to ASCII hex codes for display in SG mode
                ldx buffer
slip_in         lda #$30
                sta ascii_sc1
                sta ascii_sc2
                sta ascii_sc3
                sta ascii_sc4
                sta ascii_sc5
convert         cmpx #0
                lbeq return_ascii
                leax -1,x
                inc ascii_sc1
                lda ascii_sc1
                cmpa #$39
                bhi ascii2
                bra convert
ascii2          lda #$30
                sta ascii_sc1
                inc ascii_sc2
                lda ascii_sc2
                cmpa #$39
                bhi ascii3
                bra convert
ascii3          lda #$30
                sta ascii_sc2
                inc ascii_sc3
                lda ascii_sc3
                cmpa #$39
                bhi ascii4
                bra convert
ascii4          lda #$30
                sta ascii_sc3
                inc ascii_sc4
                lda ascii_sc4
                cmpa #$39
                bhi zero
                bra convert
ascii5          lda #$30
                sta ascii_sc4
                inc ascii_sc5
                lda ascii_sc5
                cmpa #$39
                bhi zero
                bra convert
zero            lda #$30
                sta ascii_sc5
                bra convert
return_ascii    puls x
                rts

hex2ascii       lda #$30                        ;Routine added to convert 8 bit numbers to ascii 17/04/24
                sta ascii_sc1
                sta ascii_sc2
                sta ascii_sc3
                sta ascii_sc4
                sta ascii_sc5
convert8bit     cmpb #0
                lbeq return2ascii
                decb
                inc ascii_sc1
                lda ascii_sc1
                cmpa #$39
                bhi ascii8bit
                bra convert8bit
ascii8bit       lda #$30
                sta ascii_sc1
                inc ascii_sc2
                lda ascii_sc2
                cmpa #$39
                bra convert8bit
return2ascii    rts

p2_bob_wins_code jsr sg4_setup
                jsr clrscn
                ldx #$480
                ldu #p2_bob_wins
                jsr text_code
                lbra keypress2p

p2_hog_wins_code jsr sg4_setup
                jsr clrscn
                ldx #$480
                ldu #p2_hog_wins
                jsr text_code
                lbra keypress2p

text_code1      puls x
text_code       lda ,u+
                cmpa #$2a
                lbeq  return0
                cmpa #$22
                beq ifskipped
                cmpa #$39
                beq ifskipped
                cmpa #$3a
                beq ifskipped
                cmpa #$3d
                beq ifskipped
                cmpa #$36
                beq ifskipped
                cmpa #$32
                beq ifskipped
                cmpa #$38
                beq ifskipped
                cmpa #$30
                beq ifskipped
                cmpa #$29
                beq ifskipped
                cmpa #$28
                beq ifskipped
                cmpa #$33
                beq ifskipped
                cmpa #$31
                beq ifskipped
                cmpa #$34
                beq ifskipped
                cmpa #$20
                beq ifskipped
                cmpa #$2c
                beq ifskipped
                cmpa #$21
                beq ifskipped
                cmpa #$27
                beq ifskipped
                cmpa #$35
                beq ifskipped
                cmpa #$2e
                beq ifskipped
                cmpa #$3f
                beq ifskipped
                suba    #$40
ifskipped       sta ,x+
                cmpa    #$20
                beq text_code
                inc text_beep_counter
                lda text_beep_counter
                cmpa #7                 ;how many letters skipped before a beep sounds
                beq beep_sound
                ldy #$700
text_wait       leay -1,y
                bne text_wait
                bra text_code
                
beep_sound      pshs x
                jsr beep_bob_3
                clr text_beep_counter
                bra text_code1

return0         rts

menukey     jsr [$a000]
            cmpa    #$53    ;S press
            lbeq story1_code
            cmpa    #$49    ;I press
            lbeq inst1_code
            cmpa    #$54    ;T press
            lbeq thanks1_code
            cmpa    #$31    ;1 press
            lbeq _1plr
            cmpa    #$32    ;2 press
            lbeq _2plr
            bra menukey

keypress    jsr [$a000]
            cmpa    #$0
            beq keypress
clrscn      ldx #$400
            lda #%00100000
clear1      sta ,x+
            cmpx #$600
            blo clear1
            rts

keypress2   jsr [$a000]
            cmpa    #$59    ;Y press
            lbeq    _1plr
            cmpa    #$4e    ;N press
            lbeq    menu_code          
            bra keypress2

keypress2p  jsr [$a000]
            cmpa    #$59    ;Y press
            lbeq    _2plr
            cmpa    #$4e    ;N press
            lbeq    menu_code          
            bra keypress2p

keypress3   jsr [$a000]
            cmpa    #$0
            beq keypress3
            lbra next_level

keypress_easteregg  jsr [$a000]                     ;Added 02_05_24
                    cmpa #0
                    beq keypress_easteregg
                    lbra easteregg_code

menu    fcc /  BOB AND THE ALIEN FIREFLIES   /
        fcc /      BY 8BITSINTHEBASEMENT     /
        fcc /            (C) 2024            /
        fcc /                                /
        fcc /        (S) STORY               /
        fcc /        (I) INSTRUCTIONS        /
        fcc /        (T) SPECIAL THANKS      /
        fcc /                                /
        fcc /        (1) 1 PLAYER GAME       /
        fcc /        (2) 2 PLAYER GAME*/

menu_score_text fcc /   TODAY'S HIGHEST SCORE: */

inst1   fcc /IN A 1 PLAYER GAME MOVE BOB WITH/
        fcc /A JOYSTICK PLUGGED INTO THE     /
        fcc /LEFT CONTROLLER PORT. EAT ALL   /
        fcc /THE BUGS YOU CAN BUT DON'T LET  /
        fcc /THEM GO RED FOR TOO LONG OR BOOM/
        fcc /THEY'LL EXPLODE.                /
        fcc /                                /
        fcc /AND AS IF THAT WASN'T ENOUGH, BE/
        fcc /CAREFUL NOT TO HIT EITHER OF THE/
        fcc /TWO TRANSPORTER BEAMS THAT SWEEP/
        fcc /FROM LEFT TO RIGHT AND BACK     /
        fcc /ACROSS THE SCREEN OR YOU'LL BE  /
        fcc /TRANSPORTED AWAY...*/

inst2   fcc / POINTS ARE AWARDED AS FOLLOWS: /
        fcc /FIREFLY COLLECTED    :  1 POINT /
        fcc /BLUE ROW             :  4 POINTS/
        fcc /YELLOW ROW           :  8 POINTS/
        fcc /RED ROW              : 12 POINTS/
        fcc /FULL BLOCK OF BLUE   : 32 POINTS/
        fcc /FULL BLOCK OF YELLOW : 64 POINTS/
        fcc /FULL BLOCK OF RED    : 96 POINTS/
        fcc /                                /
        fcc / TRANSPORTER SPEED INCREASES ON /
        fcc /      LEVELS 5, 10 AND 15.      /
        fcc /EACH OF THESE LEVELS AND THE TWO/
        fcc /THAT FOLLOW HAVE LARGER TELEPORT/
        fcc /BEAM GATES. ALSO BOTH BOB'S AND /
        fcc /THE BEAM'S POSITION IS NOT RESET/
        fcc /BETWEEN LEVELS... GOOD LUCK*/

inst3   fcc /IN A 2 PLAYER GAME BOB AND HOG  /
        fcc /GO HEAD TO HEAD TO BE THE FIRST /
        fcc /TO EAT A TOTAL OF 16 FIREFLIES. /
        fcc /                                /
        fcc /BOB AND HOG ARE CONTROLLED USING/
        fcc /THE LEFT AND RIGHT JOYSTICK PORT/
        fcc /                                /
        fcc /THE GAME DIFFERS FROM ONE PLAYER/
        fcc /SLIGHTLY, IF BOB OR HOG TOUCH A /
        fcc /TRANSPORTER THEY DISAPPEAR FOR A/
        fcc /COUPLE OF SECONDS. WHEN THEY    /
        fcc /COME BACK THEY'LL FLASH FOR A   /
        fcc /SHORT TIME, WHILE FLASHING THEY /
        fcc /CAN'T BE TRANSPORTED OR COLLECT /
        fcc /ANY BUGS. AND IN THIS VERSION   /
        fcc /THE FIREFLIES NEVER EXPLODE.*/

inst4   fcc /IF YOU WOULD LIKE A CHALLENGE   /
        fcc /WITHOUT HAVING TO PLAY THROUGH  /
        fcc /THE LEVELS A PRACTICE MODE HAS  /
        fcc /BEEN INCLUDED.                  /
        fcc /                                /
        fcc /TO ACCESS IT START A ONE PLAYER /
        fcc /GAME AND COLLECT A FIREFLY WHILE/
        fcc /HOLDING DOWN THE "P" KEY.       /
        fcc /                                /
        fcc /DIFFICULTY IS SET DEPENDING ON  /
        fcc /THE COLLECTED FIREFLY'S COLOUR. /
        fcc /YOUR PRACTICE SCORE IS DISPLAYED/
        fcc /AT THE END OF YOUR GAME. BUT NOT/
        fcc /RECORDED.*/

story1  fcc /ALIENS HAVE BEEN COMING TO EARTH/
        fcc /FOR A LONG, LONG TIME. GATHERING/
        fcc /FLORA, FAUNA AND OTHER SUCH CRAP/
        fcc /TO MODIFY AND EXPERIMENT ON.    /
        fcc /                                /
        fcc /AS IT HAPPENS, ON ONE OF THESE  /
        fcc /MISSIONS TWO PARTICULARLY STUPID/
        fcc /ALIEN SCOUTS NAMED D4QP AND S3E3/
        fcc /WERE TAKING SAMPLES FROM A SMALL/
        fcc /CLEARING SOMEWHERE IN IRELAND.  /
        fcc /                                /
        fcc /(IRELAND REALLY IS A NICE PLACE,/
        fcc /AND NOT MANY PEOPLE KNOW IT, BUT/ 
        fcc /IT'S THE REASON THAT TANDY CHOSE/
        fcc /GREEN FOR THE COCO. YEP, TRUE AS/
        fcc /I'M LOOKIN' AT YA THAT IS).*/


story2  fcc /WHILE TAKING A SAMPLE JAR FROM  /
        fcc /HIS POUCH, D4QP ACCIDENTALLY LET/
        fcc /A VILE FULL OF ALIEN FIREFLIES  /
        fcc /(MUCH LIKE THE TINY GLOWING BUGS/
        fcc /FOUND ON EARTH BUT WITH BIO     /
        fcc /MUTATIONAL PROPERTIES) DROP AND /         
        fcc /BURST INTO PIECES ON THE GROUND./
        fcc /                                /
        fcc /THE LITTLE GUYS FLEW OFF IN ALL /
        fcc /DIRECTIONS LIGHTING UP THE GLADE/
        fcc /AS BRIGHTLY AS IF IT WERE DAY.  /
        fcc /                                /
        fcc /OUR ALIEN FRIENDS NEEDED TO FIND/
        fcc /A WAY TO CLEAN UP THIS MESS THEY/
        fcc /HAD MADE, AND REAL FAST.*/
   
story3  fcc /SO THEY DID WHAT THEY ALWAYS DO,/
        fcc /THEY SEALED OFF THE AREA WITH   /
        fcc /ALIEN TECH TO STOP ANYONE ELSE  /
        fcc /FROM GETTING IN AND PREVENT THE /
        fcc /FIREFLIES FROM GETTING OUT.     /
        fcc /                                /
        fcc /THEN THEY SETUP TWO TRANSPORTERS/
        fcc /TO GATHER THE FIREFLIES AND TAKE/
        fcc /THEM STRAIGHT BACK TO THEIR SHIP/
        fcc /ONE BY ONE.                     /
        fcc /                                /
        fcc /ONCE THEY HAD FINISHED WITH ALL /
        fcc /THAT THEY GOT THE HECK OUT OF   /
        fcc /THERE AND HEADED BACK TO THEIR  /
        fcc /HOME PLANET.*/

story4  fcc /NEEDLESS TO SAY THE TECH DIDN'T /
        fcc /WORK VERY WELL. FOR STARTERS THE/
        fcc /TRANSPORTER FAILED MISERABLY, IT/
        fcc /COLLECTED EVERYTHING BUT FIRE   /
        fcc /FLIES.                          /
        fcc /                                /
        fcc /AND AS FOR THE BARRIER? WELL,   /
        fcc /LET'S JUST SAY, A SMALL LITTLE  /
        fcc /VERY HUNGRY HEDGEHOG NAMED BOB  /
        fcc /FOUND HIS WAY IN THERE...       /
        fcc /                                /
        fcc /THE CLEARING WAS IN IRELAND, I  /
        fcc /MENTIONED THAT, DIDN'T I? YOU   /
        fcc /REALLY SHOULD GO CHECK IT OUT   /
        fcc /THE NEXT HOLIDAY YOU GET. TELL  /
        fcc /THEM BOB SENT YOU.*/

thanks1 fcc /THIS GAME IS THE RESULT OF HOURS/
        fcc /AND HOURS SPENT OVER MONTHS UPON/
        fcc /MONTHS BEFORE A COCO 2 AND XROAR/
        fcc /AND IT WOULDN'T HAVE BEEN MADE  /
        fcc /WITHOUT THE HELP AND SUPPORT OF /
        fcc /A COUPLE OF PEOPLE, MANY THANKS /
        fcc /                                / 
        fcc /           MRDAVE6309           /
        fcc /                                /  
        fcc /    COCOTOWN RETRO ON YOUTUBE   /
        fcc /                                / 
        fcc /AS WELL AS THE COCO NATION SHOW /
        fcc /AND THE WORLDWIDE COCO COMMUNITY/
        fcc /WHO MAKE THIS HOBBY SO REWARDING/
        fcc /AND SO MUCH FUN. COCO FOREVER.*/

bug_explodes    fcc /OOOWEE!, SEEMS THAT YOU DIDN'T  /
                fcc /GET BOB TO THE BUG IN TIME AND  /
                fcc /IT'S EXPLODED, SURE IS BAD LUCK /
                fcc /                                /
                fcc /   YOUR FINAL SCORE IS : */

transporter_hit fcc /GOD DAMN, BOB HIT A TRANSPORTER /
                fcc /AND HE'S BEEN BEAMED AWAY TO WHO/
                fcc /KNOWS WHERE, I SURE HOPE HE'S OK/  
                fcc /                                /
                fcc /   YOUR FINAL SCORE IS : */

try_again       fcc /  WOULD YOU LIKE TO TRY AGAIN?*/

practice_mess   fcc /  PRACTICE MODE SCORE : */ 

p2_bob_wins     fcc /BOB WINS! BOB WINS!! BOB WINS!!!/
                fcc /                                /
                fcc /   BOB, YOU KICKED HOG'S BUTT   /
                fcc /                                /
                fcc /BOB WINS! BOB WINS!! BOB WINS!!!/
                fcc /                                /
                fcc / WOULD YOU LIKE TO PLAY AGAIN?*/   

p2_hog_wins     fcc /HOG WINS! HOG WINS!! HOG WINS!!!/
                fcc /                                /
                fcc /   HOG, YOU KICKED BOB'S ASS    /
                fcc /                                /
                fcc /HOG WINS! HOG WINS!! HOG WINS!!!/
                fcc /                                /
                fcc / WOULD YOU LIKE TO PLAY AGAIN?*/

;***********************************START OF BETWEEN LEVEL TEXT***************************

bonus_all_fill  fcc /BOB YOU CAN'T BE STOPPED, YOU'VE/     ;blue block text         
                fcc / CLEARED THE LEVEL WITH A BONUS /
                fcc /     YOUR SCORE WAS : */

blue_after      fcc / YOU'VE GONE CRAZY AND EATEN THE/
                fcc /  LITTLE FELLAS WHEN THEY WERE  /
                fcc / BLUE GIVING YOU AN EXTRA BONUS /
                fcc /                                /
                fcc / YOU GET A HUGE 32 POINTS FOR A /
                fcc /FULL BLOCK OF BLUE FIREFLIES AND/
                fcc / 16 POINTS FOR THE BUGS YOU ATE /
                fcc /                                /
                fcc /   NOW YOUR SCORE IS : */
level_txt       fcc /                                /
                fcc / YOU'RE ON A ROLL, GO GET READY /
                fcc /         FOR LEVEL */

yellow_after    fcc / IT'S OFFICIAL YOU'RE THE BUG'S /      ;yellow block text
                fcc / BOGEYMAN, THEIR BABA YAGA EVEN /
                fcc /AND YOU GONE GOT YOURSELF A BOON/
                fcc /                                /
                fcc /A FULL BLOCK OF YELLOW GIVES YOU/
                fcc /64 POINTS PLUS THE 16 POINTS FOR/
                fcc / THE 16 FIREFLIES YOU'VE EATEN  /
                fcc /                                /
                fcc /   NOW YOUR SCORE IS : */

red_after       fcc /YOU FEEL THAT.. HEARTBURN, COMES/      ;red block text
                fcc /FROM EATING EM' JUST BEFORE THEY/
                fcc /  GO BOOM.  YOU'RE ON FIRE BOB  /
                fcc /                                /
                fcc / AN ENTIRE GRID OF RED GETS YOU /
                fcc /A WHOPPING 96 POINTS AND 16 MORE/
                fcc /FOR ALL THOSE BUGS YOU'VE EATEN /
                fcc /                                /
                fcc /   NOW YOUR SCORE IS : */

bonus_bug_line  fcc /WELL DONE BOB YOU'VE CLEARED THE/      ;lines bonus
                fcc /   LEVEL YOU SURE WERE HUNGRY   /
                fcc /     PREVIOUS SCORE : */

line_data_blue  fcc / BLUE LINES   X 4  = */           ;short line cause number data score comes before
line_data_yell  fcc / YELLOW LINES X 8  = */           ;short line cause number data score comes before
line_data_red   fcc / RED LINES    X 12 = */           ;short line cause number data score comes before

line_data_16    fcc /  PLUS 16 POINTS FOR CLEARING   /
                fcc /THE LEVEL NEW SCORE : */

line_data_16_2  fcc /NOW GO EAT SOME BUGS, GET READY /
                fcc /          FOR LEVEL */ 

practice_text   fcc /    YOU ARE IN PRACTICE MODE    /
                fcc /          IT'S FUN TO GO        /
                fcc /  FAST WITHOUT HAVING TO DO ALL /
                fcc /     THAT LEVEL PROGRESSION     /
                fcc /                                / 
                fcc /          GOOD LUCK...*/

easteregg_text1     fcc /STAND BY ...332455555522255556*/                 ;ADDED 02_05_24
easteregg_text2     fcc /ANNOMALLY DETECTED IN SECTOR 326*/
easteregg_text3     fcc /DNA SUB STRUCTURE MELD DETECTED.*/
easteregg_text4     fcc /BRINGING UP MONITOR FOR VISUAL  /
                    fcc /VERIFICATION...*/
easteregg_text5     fcc /ERROR...*/ 

eggend_text         fcc /GREAT GOING, YOU'VE UNLOCKED THE/                      ;added04_05_24
                    fcc /BIO MUTATIONAL POWER OF THE     /
                    fcc /ALIEN FIREFLIES AND DISCOVERED  /
                    fcc /THE GAME'S EASTER EGG.HAVE AN   /
                    fcc /EXTRA 50 POINTS ON BOB...       /
                    fcc /                                /
                    fcc /                                /
                    fcc /    YOUR FINAL SCORE : */



drawjar1p       leax -$41,x
nextjarline     ldb #46
                ldu #jarobugs
jardraw         lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                lda ,u+
                sta ,x+
                decb
                bne jumpline
                rts
jumpline        leax $13,x
                bra jardraw

cork1p          leax $18c,x
nextcorkline    ldb #18
                ldu #cork
corkdraw        lda ,u+
                sta ,x+
                decb
                bne jumpcorkline
                rts
jumpcorkline    leax $1f,x
                bra corkdraw      

jarobugs        fcb 2,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$00
                fcb 10,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$80
                fcb 10,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$a0
                fcb 10,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,34
;********The cork sits between this part of the bottle**********
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,34
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,41
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,41
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,101
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,69
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,69
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,81
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,85
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,101
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,41
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,41
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,34
;*********************and this part here************************
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,34
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 40,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 10,0,0,0,0,0,0,0,0,0,0,0,32
                fcb 10,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$a0
                fcb 10,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$80
                fcb 2,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa,$00

cork            fcb 84
                fcb 85
                fcb 81
                fcb 84
                fcb 69
                fcb 85
                fcb 84
                fcb 21
                fcb 85
                fcb 85
                fcb 81
                fcb 69
                fcb 85
                fcb 81
                fcb 85
                fcb 21
                fcb 85
                fcb 84

        end     $3600           ;Program ends here, included the start address so that "lwasm" would make it the exec point when compiled.




